/**
 * MapButton
 */

var map = null;

var MapButton = {
		type: 'MapButton',
		drawControl: function(control, tab){
			var tabDiv = $("#"+tab.tabType+"-"+tab.tabId);
			var imageUrl = control.imageUrl;
			var	ctrlDiv = $('<a></a>')
							.attr('href', '#')
							.attr('id', tab.tabId + '-' + control.controlId)
							.append(
								$('<img></img>')
											.data('control', control)
											.data('tab', tab)
											.attr('src', imageUrl)
											.css({width: control.frame.width+'px', 
												height: control.frame.height+'px',
												position: 'absolute',
												top: control.frame.top+'px',
												left: control.frame.left+'px',
												margin: '0px',
												'font-size': '10px'})
											.click(function(){})
								);
								/*.click(function(){
									var url = $(this).data('href');
									window.location = url;
									if(window.Ext !== undefined){
										window.location = url;
									}
									else{
										return false;
									}
								});*/
			var screen = $('<div></div>')
							.attr('id', 'map-screen-'+control.controlId)
							.css({display:'none'})
							.addClass('child-screen');
			var mapUrl = GS.mapPageUrl + "?center=" + escape(GS.location.latitude+","+GS.location.longitude) + "&height=" + (GS.screenY - 150);
			var mapStruct = $('<iframe src="map.html" style="width:100%; height:' + GS.screenY + 'px"></iframe>');
			/*var mapStruct = 			
				'<div data-role="content">'+
				'<div class="ui-bar-c ui-corner-all ui-shadow" style="padding:1em;">'+
				'<div id="map-canvas-' + control.controlId + '" style="height:' + (GS.screenY - 100) + 'px;"></div></div></div>';
			
			screen.append(
					$('<div></div>')
						.attr('id', 'map-container-'+control.controlId)
						.attr("data-role", "page")
						.css({ 'width':'100%', 'height':'100%' })
						.append($(mapStruct))
			);*/
			//ctrlDiv.button();
			tabDiv.append(ctrlDiv);
			tabDiv.append(screen);
			MapButton.GetLocations(control, tab);
			//MapButton.initializeMap(control.controlId);
		},
		GetLocations: function(control, tab){
			var mapUrl = GS.mapPageUrl + "?height=" + (GS.screenY - 250)+
							"&center=" + (GS.location.latitude+","+GS.location.longitude)+
							"&lat=" + GS.location.latitude +
							"&lng=" + GS.location.longitude +
							"&appId=" + app.appId +
							"&listId=" + control.controlId;
			$("#" + tab.tabId + "-" + control.controlId).attr('href', mapUrl);
            /*var url = GS.processorUrl+"/RequestProcessor.ashx?cmd=getBusinesses" +
			"&controlId=" + control.controlId +
			"&appId=" + app.appId;
            $.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(url), 
		    		function (data, status){
			    		//alert("Status: " + status);
			    		if(status == 'success'){
			    			var rawXml = unescape(proxy_resp.content);
			    			var xmlDoc = $.parseXML(rawXml);
			    			var businesses = $(xmlDoc).find('business');
			    			var busArray = new Array();
			    			for(var i=0; i<businesses.length;i++){
			    				var bus = $(businesses[i]);
			    				var name = bus.find('name')[0].textContent;
			    				var url = bus.find('url')[0].textContent;
			    				var description = bus.find('description')[0].textContent;
			    				var logo = bus.find('logo')[0].textContent;
			    				var emails = bus.find('email');
			    				var mailArray = new Array();
			    				for(var j=0; j<emails.length; j++){
			    					var mail = emails[j];
			    					var email = mail.textContent;
			    					mailArray.push(email);
			    				}
			    				var addresses = bus.find('address');
			    				var adrArray = new Array();
			    				for(var j=0;j<addresses.length;j++){
			    					var address = addresses[j];
			    					var city = $(address).find('city')[0].textContent;
			    					var country = $(address).find('country')[0].textContent;
			    					var postalCode = $(address).find('postalCode')[0].textContent;
			    					var region = $(address).find('region')[0].textContent;
			    					var street = $(address).find('street')[0].textContent;
			    					var latitude = $(address).find('latitude')[0].textContent;
			    					var longitude = $(address).find('longitude')[0].textContent;
			    					adrArray.push({city:city, country:country, postalCode:postalCode, 
			    									region:region, street:street, latitude:latitude, 
			    									longitude:longitude});
			    					
			    				}
			    				var phones = bus.find('phones');
			    				var phArray = new Array();
			    				for(var j=0;j<phones.length;j++){
			    					var phone = phones[j].textContent;
			    					phArray.push(phone);
			    				}
			    				
			    				var business = {name:name, description:description, logo:logo, url:url, 
			    								emails: mailArray, addresses: adrArray, phones: phArray, num: i};
			    				busArray.push(business);
			    			}
			    			
			    			var markersJson = "{ 'markers':" + JSON.stringify(busArray) + "}";
			    			window.localStorage.setItem("map-markers", markersJson);
			    			//$("#map-container-"+control.controlId).find('iframe')[0].contentDocument.location.reload(true);		    			
			    		}
            		});*/
		},
		initializeScript: function(controlId) {
			  var script = document.createElement("script");
			  script.type = "text/javascript";
			  script.src = "http://maps.googleapis.com/maps/api/js?sensor=true&callback=MapButton.initializeMap('" + controlId + "')";
			  document.body.appendChild(script);
		},	
		initializeMap: function(controlId) {
			return;
	        var latlng = new google.maps.LatLng(GS.location.latitude, GS.location.longitude);
	        var myOptions = {
	            zoom: 8,
	            scaleControl: true,
	            navigationControl: true,
	            navigationControlOptions: {
	                style: google.maps.NavigationControlStyle.ANDROID
	            },
	            mapTypeControl: true,
	            mapTypeControlOptions: {
	                style: google.maps.MapTypeControlStyle.DROPDOWN_MENU
	            },
	            streetViewControl: false,
	            //center: latlng,
	            mapTypeId: google.maps.MapTypeId.ROADMAP
	        };

	        $("#map-container-" + controlId).gmap().bind('init', function() { 
	            $.getJSON( 'http://jquery-ui-map.googlecode.com/svn/trunk/demos/json.json', function(data) { 
	                $.each( data.markers, function(i, m) {
	                    $('#map_canvas').gmap('addMarker', { 'position': new google.maps.LatLng(m.lat, m.lng), 'bounds': true } );
	                });
	            });
	        });
          /*map = new GMap(document.getElementById("map-container-" + controlId)); 
          map.addControl(new GSmallMapControl()); 
          map.setMapType(G_SATELLITE_TYPE); 
          map.centerAndZoom(new GPoint(GS.location.latitude, GS.location.longitude), 4); */
		}
}