/**
 * PoweredBy Tab
 */

var PoweredBy = {
		type: 'PoweredBy',
		GetScreen:function(tab){
			var div=$('#'+tab.tabType+'-'+tab.tabId);
			var background = $('<img></img>')
								.attr('src', 'http://storage.store2phone.com/temp/snappiiSplash.png')
								.css({ width:'100%', height:'100%'});
			
			var btnTop = GS.screenY/2;
			var btnLeft = (GS.screenX-270)/2;
			var imageHeight = (btnTop - 30);
			var imageWidth = (btnTop - 30) * 1.7;
			if(imageWidth > GS.screenX) {
				imageWidth = GS.screenX;
				imageHeight = imageWidth / 1.7;
			}
			var imageMargin = (GS.screenX - imageWidth) / 2;
			
			var logo = $('<img></img>')
						.attr('src', 'images/snappii-logo-512.png')
						.css({ height: imageHeight + 'px', width: imageWidth + 'px', 'margin-left': imageMargin + 'px' });
			var callBtn = $('<a>Call Us</a>')
							.attr('data-role', 'button')
							.attr('href', 'tel:(603) 397 3044')
							.css({ width: '120px', height: '30px',
								    left: btnLeft + 'px',
								    position: 'absolute',
								    top: btnTop + 'px'});
			var emailBtn = $('<a>Email Us</a>')
							.attr('data-role', 'button')
							.attr('href', 'mailto: support@snappii.com')
							.css({ width: '120px', height: '30px',
									left: (btnLeft + 170) + 'px',
								    position: 'absolute',
								    top: btnTop + 'px'});
			var apptesterBtn = $('<a>Download Snappii AppTester</a>')
								.attr('data-role', 'button')
								.attr('href', 'market://details?id=com.snappii.retail_managment_network')
								.css({ width: '290px', height: '30px',
										left: btnLeft + 'px',
									    position: 'absolute',
									    top: (btnTop + 50) + 'px'});
			var browseBtn = $('<a>Browse Snappii Apps in Store</a>')
								.attr('data-role', 'button')
								.attr('href', 'https://market.android.com/developer?pub=Snappii')
								.css({ width: '290px', height: '30px',
										left: btnLeft + 'px',
									    position: 'absolute',
									    top: (btnTop + 100) + 'px'});
			div
				.append(logo)
				.append(callBtn)
				.append(emailBtn)
				.append(apptesterBtn)
				.append(browseBtn);
		},
		onOpen: function(tab){
			$($("#PoweredBy-" + tab.tabId).children()[0]).css({ display: 'block', height: GS.screenY + 'px' });
		}
}