/**
 * Dialog for global settings
 */

var Settings = {
				type: 'Search',
				GetScreen: function(tab){
					var div= $("#settings-screen");
					$("#settings-screen").empty();
					
					var txtCurrentAddress = $('<div data-role="fieldcontain">'+
											    '<label for="txt-my-address">Current Location:</label>'+
											    '<input type="text" name="name" id="txt-current-address" value="' + currentLoc + '" disabled="disabled" />'+
											'</div>');
					
					var txtAddress = $('<div data-role="fieldcontain">'+
									    '<label for="txt-my-address">Your Address:</label>'+
									    '<input type="text" name="name" id="txt-my-address" value=""  />'+
									'</div>');
					var controlGroup = $('<div data-role="controlgroup" data-type="horizontal"></div>')
										.css({ 'text-align': 'center' });
					
					var btnLocate = $('<a href="#" data-role="button">Search Location</a>')
									.css({ height: '40px', 'width': '150px' })
									.addClass("btn-fix-settings")
									.click(function(){
										var address = $('#txt-my-address').val();
										if(address.length < 1){
											alert("Search string is empty");
											return;
										}
										$.mobile.showPageLoadingMsg();
										var url = 'http://maps.googleapis.com/maps/api/geocode/json?address='
													+escape(address)+'&sensor=false';
										$("#search-list-places").remove();
										$.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(url), 
									    		function (data, status){
										    		//alert("Status: " + status);
										    		if(status == 'success'){
										    			var rawJson = eval("("+unescape(proxy_resp.content)+")");
										    			var places = new Array();
										    			var ul = $('<ul data-role="listview" class="ui-listview" id="search-list-places"></ul>');
										    			ul.css({ 'margin-top':'10px', 'margin-left': '0px', height: (rawJson.results.length * 40) + 'px' });
										    			ul.addClass('rss-ul');
										    			for(var i=0;i<rawJson.results.length;i++){
										    				var res = rawJson.results[i];
										    				ul.append(Settings.showSearchResult({'address': res.formatted_address,
										    													'location': res.geometry.location}))
										    			}
										    			
										    			$("#settings-screen").append(ul);
										    			ul.listview();
										    			proxy_resp = null;
										    		}
										    		$.mobile.hidePageLoadingMsg();
									    		});
									});
					var btnGPS = $('<a href="#" data-role="button">Use Current Location</a>')
									.css({ height: '40px', 'width': '170px' })
									.addClass("btn-fix-settings")
									.click(function(){
										$.mobile.showPageLoadingMsg();
										navigator.geolocation.getCurrentPosition(function(position){ 
								    		GS.location = position.coords;
								    		getFromGPS = true;
											currentLoc = GS.location.latitude + ", " + GS.location.longitude;
											$("#txt-current-address").val(currentLoc);
											window.localStorage.setItem("my-latitude", GS.location.latitude);
											window.localStorage.setItem("my-longitude", GS.location.longitude);
											Log.WriteLog("Location success. Latitude: "+GS.location.latitude + ", " + GS.location.longitude);
											$.mobile.hidePageLoadingMsg();
								    	}, function(error){
								    		$.mobile.hidePageLoadingMsg();
								    		alert('Can not get your current location.');
								    	},
								    	{ maximumAge: 300000, timeout: 5000, enableHighAccuracy: true });
									});
					var btnSave = $('<a href="#" data-role="button" data-inline="true">Save</a>')
									.click(function(){
										
									});
					div
						.append(
								$('<div></div>')
									.css({ margin: '10px' })
									.append(
											$('<div></div>')
												.append(txtCurrentAddress)
												.append(txtAddress)
									)
									.append(
											controlGroup
												.append(btnLocate)
												.append(btnGPS)
									)
								);
				},
				AddSettings: function(){
					var div = $('<div></div>')
								.attr('id', "settings-screen")
								.css({display:'none'})
								.addClass('screen-view')
								.attr("data-scroll", "y");
					$("#content-body").append(div);
					Settings.GetScreen(0);
					$("#settings-btn").click(function(){
						$('.screen-view').css({display:'none'});
						$("#settings-screen").css({display:'block'});
						$($("#settings-screen").children()[0]).css({display:'block', background: 'transparent'});
						$("#settings-screen").find('.ui-field-contain').css({ background: 'none repeat scroll 0 0 transparent' });
						$("#settings-screen").find('.ui-page').css({display: 'block', position: 'relative', background: 'none repeat scroll 0 0 transparent'});
						//$("#footer").css({ display:'none' });
						$("#header-text").text('Settings');
						GS.hideBackBtn();
						$("#save-settings-btn").parent().css({ display:'block' });
						$("#save-settings-btn").css({ display:'block' });
						$("#save-settings-btn").click(function(){
							$("#save-settings-btn").css({ display:'none' });
							$("#settings-screen").css({ display:'none' });
							RenderLocationControls();
							//$("#footer").css({ display:'block' });
							$("#"+lastActiveTabId).css({ display:'block' });
						});
						//$("#"+$(this).data('id')).css({display:'block'});
						//$("#header-text").text($(this).data('name'));
						$(".child-screen").css({display:'none'});
						//$("#location-dialog").css({display:'block'});
						//LocatorDialog.showDialog();
					});
				},
				showSearchResult: function(place){
					var li = $('<li></li>')
								.attr('data-theme', 'c')
								.addClass('ui-btn')
								.addClass('ui-li')
								.addClass('ui-btn-icon-right')
								.addClass('ui-btn-up-c')
								.css({width:'100%', 'height': '30px'})//.css({width:GS.screenX+'px'})
								.data('location',place.location)
								.data('address', place.address)
								.click(function(){
									var loc = $(this).data('location');
									GS.location = {latitude:loc.lat, longitude:loc.lng};
									window.localStorage.setItem("my-latitude", GS.location.latitude);
									window.localStorage.setItem("my-longitude", GS.location.longitude);
									currentLoc = $(this).data('address');
									$("#txt-current-address").val(currentLoc);
									getFromGPS = false;
									return false;
								});
					li.append($('<p>' + place.address + '</p>')
								.css({'font-size':'14px', 'font-weight':'bold', 'margin-left':'20px', 'margin-top': '5px'})
					);
					return li;
					
				}
}