/**
 * Signup button
 */

var SignupButton = {
		type: 'SignupButton',
		drawControl: function(control, tab){
			var tabDiv = $("#"+tab.tabType+"-"+tab.tabId);
			var screen = $('<div></div>')
			.attr('id', 'signup-screen-'+tab.tabId)
			.css({display:'none'})
			.addClass('child-screen');
			var lblText = $('<p>Sign up to participate in discussions and to write reviews</p>');
			var txtEmail = $('<div data-role="fieldcontain">'+
				    '<label for="txtEmail-signup-' + tab.tabId + '">Email Address:</label>'+
				    '<input type="text" name="name" id="txtEmail-signup-' + tab.tabId + '" value="" class="form-input" />'+
				'</div>');
			var txtName = $('<div data-role="fieldcontain">'+
				    '<label for="txtName-' + tab.tabId + '">User name:</label>'+
				    '<input type="text" name="name" id="txtName-' + tab.tabId + '" value="" class="form-input"  />'+
					'</div>');
			var txtPassword = $('<div data-role="fieldcontain">'+
				    '<label for="txtPassword-signup-' + tab.tabId + '">Password:</label>'+
				    '<input type="password" name="name" id="txtPassword-signup-' + tab.tabId + '" value="" class="form-input" />'+
					'</div>');
			var txtLocation = $('<div data-role="fieldcontain">'+
				    '<label for="txtLocation-' + tab.tabId + '">Location:</label>'+
				    '<input type="text" name="name" id="txtLocation-' + tab.tabId + '" value="" class="form-input" />'+
					'</div>');
			var btnSignup = $('<a href="#" data-role="button" data-inline="true">SignUp</a>')
							.data('id', tab.tabId)
							.css({ width: '120px', height: '30px' })
							.click(function(){
								var id = $(this).data('id');
								var txtEmail = $("#txtEmail-signup-" + id).val();
								var txtName = $("#txtName-" + id).val();
								var txtPass = $("#txtPassword-signup-" + id).val();
								var txtLocation = $("#txtLocation-" + id).val();
								var signupUrl = GS.processorUrl + "/RequestProcessor.ashx?cmd=&addUser&email=" + escape(txtEmail)+ 
												"&name=" + escape(txtName) +
												"&password="+escape(txtPass) +
												"&location="+escape(txtLocation) +
												"&platform=2";
								var lat = "91";
								var lng = "181";
								if(GS.location!=null){
									if(GS.location.latitude!==undefined){
										lat = GS.location.latitude;
										lng = GS.location.longitude;
									}
								}
								signupUrl += ("&latitude="+GS.location.latitude+"&longitude="+GS.location.longitude);
								
								if(window.Ext !== undefined){
									signupUrl = window.Ext.GetSignupUrl(GS.processorUrl, txtEmail, txtPass, txtName, txtLocation, lat, lng);
								}
								$.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(signupUrl), 
							    		function (data, status){
								    		//alert("Status: " + status);
								    		if(status == 'success'){
								    			var xml = unescape(proxy_resp.content);
								    			if(xml == 'Web error'){
								    				var message = 'Server side error.';
								    				alert(message);
								    			}
								    			else{
								    				if(window.Ext !== undefined){
								    					xml = window.Ext.Decrypt(unescape(xml));
								    				}
								    				var xmlDocL = $.parseXML(xml);
								    				alert("Registration Complete!");
								    			}
								    			proxy_resp = null;
								    		}
							    		});
								return false;
							});
			var form = $('<div></div>').css({'margin': '10px', height: '100%'});
			form
				.append(lblText)
				.append(txtEmail)
				.append(txtName)
				.append(txtPassword)
				.append(txtLocation)
				.append(btnSignup);
			screen.append(form);
			var ctrlDiv = $("<a></a>")
							.append(
									$('<img src="' + control.imageUrl + '" />')
											.css({width: control.frame.width+'px', 
												  height: control.frame.height+'px'})
							)
							.addClass('control-button')
							.data('control', control)
							//.attr("data-role", "button")
							.data('id', tab.tabId)
							.css({width: control.frame.width+'px', 
								height: control.frame.height+'px',
								position: 'absolute',
								top: control.frame.top+'px',
								left: control.frame.left+'px',
								margin: '0px',
								'font-size': GS.standardFontSize + 'px'})
							.click(function(){
								$("#signup-screen-"+$(this).data('id')).css({'display':'block'});
								GS.showBackBtn();
								BackStack.down({ screenId: "signup-screen-"+$(this).data('id')});
								/*GS.BackBtn
								//.unbind()
								.data('screenid', "signup-screen-"+$(this).data('id'))
								.click(function(){
									$("#"+$(this).data('screenid')).css({display:'none'});
									GS.hideBackBtn();
								})*/
								return false;
							});
			tabDiv.append(ctrlDiv);
			tabDiv.append(screen);
		}
}