/**
 * App Initialization
 */

function initFooter(){
	var footerPos = GS.screenY - 65;
	if(window.device === undefined){
		//for browser
		footerPos = window.screen.availHeight - 65;
	}
	else{
		if(window.device.version.indexOf("3.0") >= 0){
			GS.screenY - 105;
		}
	}
	
	$("#footer").css({ bottom: '0', display: 'block', width: '100%', position: 'fixed' });
}

function init(){
	/*$("#splashscren").click(function(){
		$("#splashscren").css({display:'none'});
		$("#mainscreen").css({display:'block'});
	});*/
	
	Log.WriteLog("X: " + GS.screenX + "; Y: " + GS.screenY);
	
	initFooter();
	initHeader();
	$("#screen-content").css({height:(GS.screenY-$("#footer").height()-$("#header").height()-10)+'px'});
	GS.BackBtn = $($("#header").find('.header-back-btn')[0]);
	if(isViewer == false){
		$("#back-to-apps-btn").css({display:'none'});
	}
	else{
		$("#back-to-apps-btn")
			.css({display:'block'});
		$("#back-to-apps-btn")
			.click(function(){
				$.mobile.changePage($("#preview-login"));
				return false;
			});
		GS.hideBackBtn();
	}
	/*if(isViewer == false){
		$("#header").find('div').css({display:'none', width: '90px', height: '40px', position: 'absolute', left:'0px'});
	}
	else{
		$("#header").find('div')
			.css({display:'block', width: '90px', height: '40px', position: 'absolute', left:'0px'});
			.click(function(){
				$.mobile.changePage($("#preview-login"));
				return false;
			});
	}*/
	
	$.each($('.custom-tab'), function(key, value){
		var div = $(value).children()[0];
		//div.css({ height: '320px'});
	});
	
	initDateTimePicker();
	//Locator.loadCountries();
	//LocatorDialog.createBody();
	//LocatorDialog.showDialog();
	//set page height
	//$("#screen-content").css({'height':GS.screenY});

}

function initHeader(){
	var backBtn = 
		$('<button>Back<button/>')
					//.attr('data-role', 'button')
					//.attr('href', '#')
					.addClass('btn-fix')
					.addClass('ui-btn')
					.addClass('ui-btn-corner-all')
					.addClass('ui-shadow')
					.addClass('ui-btn-up-a')
					.attr('id', 'back-btn')
					.css({width:'60px', height:'30px'})
					.bind( "click", function(event, ui) {
						BackStack.up();
					});
	var backToAppsBtn = 		
		$('<button>Back to App List<button/>')
			.addClass('btn-fix')
			.addClass('ui-btn')
			.addClass('ui-btn-corner-all')
			.addClass('ui-shadow')
			.addClass('ui-btn-up-a')
			.attr('id', 'back-to-apps-btn')
			.css({width:'120px', height:'30px'})
			.bind( "click", function(event, ui) {
				$.mobile.changePage($("#preview-login"));
				return false;
			});
	
	var settingsBtn = 		
		$('<button>Settings<button/>')
			.addClass('btn-fix')
			.addClass('ui-btn')
			.addClass('ui-btn-corner-all')
			.addClass('ui-shadow')
			.addClass('ui-btn-up-a')
			.addClass('ui-btn-right')
			.attr('id', 'settings-btn')
			.css({width:'120px', height:'30px'})
			.bind( "click", function(event, ui) {
			});
	
	var saveSettingsBtn = //save-settings-btn-div
		$('<button>Save<button/>')
			.addClass('btn-fix')
			.addClass('ui-btn')
			.addClass('ui-btn-corner-all')
			.addClass('ui-shadow')
			.addClass('ui-btn-up-a')
			.attr('id', 'save-settings-btn')
			.css({width:'60px', height:'30px'})
			.bind( "click", function(event, ui) {
			});
	
	$("#back-btn-div").css({width:'80px', position: 'absolute', top: '5px', left: '5px'}).empty().append(backBtn[0]);
	$("#back-to-apps-btn-div").css({width:'130px', position: 'absolute', top: '5px', left: '70px'}).empty().append(backToAppsBtn[0]);
	$("#settings-btn-div").css({width:'130px'}).empty().append(settingsBtn[0]);
	$("#save-settings-btn-div").css({width:'60px', position: 'absolute', top: '5px', left: '5px'}).empty().append(saveSettingsBtn[0]);
}

function initLogin(){
	GS.checkFirstStart();
	if(window.Ext !== undefined){
		var regId = window.Ext.GetRegistrationId();
		//alert("App reg Id: " + regId);
		if(regId == ""){
			//alert('Call register method');
			var res = window.Ext.RegisterForNotification();
		}
		//alert(res);
	}
	if($("#login-btn").length > 0){
		return;
	}
	if(isViewer == true){
		Log.WriteLog("Init Login Elements");
		//$("#login-div").empty();
		var loginBtn = //$("#login-btn").css({ width: '100px' });
			$('<button>Login<button/>')
						//.attr('data-role', 'button')
						//.attr('href', '#')
						.addClass('btn-fix')
						.addClass('ui-btn')
						.addClass('ui-btn-corner-all')
						.addClass('ui-shadow')
						.addClass('ui-btn-up-c')
						.attr('id', 'login-btn')
						.css({width:'100px', height:'30px'})
						.bind( "click", function(event, ui) {
							var txtUser = $("#user-login").val();
							var txtPassword = $("#user-password").val();
							if(window.localStorage !== undefined){
								window.localStorage.setItem("snappii-login", txtUser);
								window.localStorage.setItem("snappii-password", txtPassword);
							}
							userLogin(txtUser, txtPassword);
							return false;
						});
		var demoAppsBtn = //$("#login-btn").css({ width: '100px' });
			$('<button>View Demo Apps<button/>')
						//.attr('data-role', 'button')
						//.attr('href', '#')
						.addClass('btn-fix')
						.addClass('ui-btn')
						.addClass('ui-btn-corner-all')
						.addClass('ui-shadow')
						.addClass('ui-btn-up-c')
						.attr('id', 'demo-apps-btn')
						.css({width:'140px', height:'30px'})
						.bind( "click", function(event, ui) {
							$("#login-div").hide();
							drawAppList(0, 0, true);
							return false;
						});
		/*loginBtn.button({
			   create: function(event, ui) {}
		});*/
		$("#login-div").append(
				$('<table></table>')
					.append(
							$('<tr></tr>')
								.append(
										$('<td></td>')
											.append(loginBtn[0])
								)
								.append(
										$('<td></td>')
											.append(demoAppsBtn[0])
								)
					)
		);
		
		
		//$("#login-div").append(loginBtn[0]);
		//$("#login-div").append(demoAppsBtn[0]);
		//$("#demo-apps-div").append(demoAppsBtn[0]);
		if(window.localStorage !== undefined){
			$("#user-login").val(window.localStorage.getItem("snappii-login"));
			$("#user-password").val(window.localStorage.getItem("snappii-password"));
		}
	}
	else{
		$("#preview-login").hide();
		$.mobile.changePage($("#mainscreen"));
	}
}

function initSplash(){
	$("#splash-img")
		.attr('src', GS.splashsreen)
		.css({
			'margin':'5px'
		});
	var h = 640;
	var w = 320;
	var min = Math.min(GS.screenX, GS.screenY);
	if(GS.screenX > GS.screenY){
		h = GS.screenY;
		w = h*2/3;
	}
	else{
		w = GS.screenX;
		h = w*3/2;
	}
	$("#splash-img").css({ width:w+'px', height:h+'px' });
	$("#screen-content")
		.css({height:(GS.screenY-$("#footer").height()-$("#header").height()-10)+'px'});
}