/**
 * functions for user login
 */

function userLogin(username, password){
	//alert("User Login Started");
	$.mobile.showPageLoadingMsg();
	var loginUrl = GS.processorUrl + "/RequestProcessor.ashx?cmd=login&email=" 
		+escape(username)+ "&password=" + escape(password);
	if(window.Ext !== undefined){
		loginUrl = window.Ext.GetLoginUrl(GS.processorUrl, username, password);
	}
	
	Log.WriteLog("User Login");
	$.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(loginUrl), 
		function (data, status){
		//alert("Status: " + status);
		Log.WriteLog("User Login Status: " + status);
		if(status == 'success'){
			var xml = unescape(proxy_resp.content);
			if(xml == 'Web error'){
				Log.WriteLog("User Login Failed");
				var message = 'Email address and password do not match.';
				alert(message);
			}
			else{
				Log.WriteLog("User Login Success");
				if(window.Ext !== undefined){
					xml = window.Ext.Decrypt(unescape(xml));
				}
				var xmlDocL = $.parseXML(xml);
				var id = $(xmlDocL).find('id')[0].textContent;
				var email = $(xmlDocL).find('email')[0].textContent;
				var name = $(xmlDocL).find('name')[0].textContent;
				GS.user = { 'name': name, 'id':id, 'email': email};
				//GS.BackBtn.trigger('click');
				$("#login-div").hide();
				drawAppList(id, 0, false);
			}
			proxy_resp = null;
			initFooter();
			$.mobile.hidePageLoadingMsg();
		}
	});
}

function drawAppList(userId, page, isDemo){
	$.mobile.showPageLoadingMsg();
	$("#login-container").hide();
	$("#logout-btn-div").show();
	$("#app-list-container").show();
	$("#more-apps-btn-container").show();
	
	//logout-btn-div
	if($("#logout-user-btn").length == 0){
		if(isDemo == false){
			var logoutUserBtn = //save-settings-btn-div
				$('<button>Logout<button/>')
					.addClass('btn-fix')
					.addClass('ui-btn')
					.addClass('ui-btn-corner-all')
					.addClass('ui-shadow')
					.addClass('ui-btn-up-c')
					.attr('id', 'logout-user-btn')
					.css({width:'80px', height:'50px', 'font-size':'18px'})
					.bind( "click", function(event, ui) {
						$("#login-container").show();
						$("#login-div").show();
						$("#logout-btn-div").hide();
						$("#logout-btn-div").empty();
						$("#app-list-container").empty();
						$("#more-apps-btn-container").empty();
						$("#app-list-container").hide();
						$("#more-apps-btn-container").hide();
					});
			$("#logout-btn-div").append(logoutUserBtn[0]);
		}
	}
	if($("#demo-back-btn").length == 0){
		if(isDemo == true){
			var backBtn = 
				$('<button>Exit from Demo Apps<button/>')
					.addClass('btn-fix')
					.addClass('ui-btn')
					.addClass('ui-btn-corner-all')
					.addClass('ui-shadow')
					.addClass('ui-btn-up-c')
					.attr('id', 'demo-back-btn')
					.css({width:'220px', height:'50px', 'font-size':'18px'})
					.bind( "click", function(event, ui) {
						$("#login-container").show();
						$("#login-div").show();
						$("#logout-btn-div").hide();
						$("#logout-btn-div").empty();
						$("#app-list-container").empty();
						$("#more-apps-btn-container").empty();
						$("#app-list-container").hide();
						$("#more-apps-btn-container").hide();
					});
			$("#logout-btn-div").append(backBtn[0]);
		}
	}
	
	var appUrl = GS.processorUrl + "/RequestProcessor.ashx?cmd=getAppList&start=" + page + "&getDemoApps=" + isDemo + "&userId=" 
					+userId+ "&format=json";
	if(window.Ext !== undefined){
		appUrl = window.Ext.GetAppListUrl(GS.processorUrl, page, isDemo, userId);
	}
	$.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(appUrl), 
		function (data, status){
		//alert("Status: " + status);
		if(status == 'success'){
			var json = unescape(proxy_resp.content);
			if(json == 'Web error'){
				var message = 'Server side error.';
				alert(message);
			}
			else{
				if(window.Ext !== undefined){
					json = window.Ext.Decrypt(unescape(json));
				}
				var appsObject = eval("("+json+")");
				if(appsObject.apps.Application !== undefined){
					var list = $('<ul id="app-list" data-role="listview" class="ui-scrollview-view ui-listview" data-theme="g"></ul>');
					if(appsObject.apps.Application.id === undefined){
						for(var i=0; i<appsObject.apps.Application.length; i++){
							var app = appsObject.apps.Application[i];
							list.append(DrawAppItem(app));
						}
					}
					else{
						list.append(DrawAppItem(appsObject.apps.Application));
					}
					//GS.BackBtn.trigger('click');
					//$("#app-list").listview();
					$("#login-container").css({ display:'none'});
					$("#app-list-container").append(list);
					list.listview();
					//$.mobile.changePage($("#app-list-page"));
					
					var appCount = $("#app-list-container").find(".app-list-item").length;
					if(appCount >= 25 && $("#more-apps-btn").length == 0){
						//more-apps-btn-container
						var moreAppBtn = 
							$('<button>More...<button/>')
								.addClass('btn-fix')
								.addClass('ui-btn')
								.addClass('ui-btn-corner-all')
								.addClass('ui-shadow')
								.addClass('ui-btn-up-a')
								.data('page', 0)
								.attr('id', 'more-apps-btn')
								.css({width:'80px', height:'30px'})
								.bind( "click", function(event, ui) {
									var nextPage = $(this).data('page') + 1;
									drawAppList(userId, nextPage, isDemo);
								});
						$("#more-apps-btn-container").append(moreAppBtn[0]);
					}
					$("#more-apps-btn").data('page', page);
				}
				else{
					alert("You have no apps");
				}	
			}
			proxy_resp = null;
		}
		$.mobile.hidePageLoadingMsg();
	});
}

function DrawAppItem(app){
	var icon = app.icon;
	$("#app-list-item-" + app.id).remove();
	var kX = Math.min(GS.screenX, GS.screenY) / 320;
	//alert(GS.screenX + "; " + GS.screenY + "; " + kX + ";" + Math.min(80, (32*kX + 10)));
	var kF = 1;
	if(kX > 1){
		kF = 1 + (kX - 1)/2;
	}
	var li = $('<li></li>')
				.attr('id', 'app-list-item-' + app.id)
				.data('id', app.id)
				.addClass('app-list-item')
				.data('name', app.name)
				//.addClass('ui-li')
				.attr('data-theme', 'c')
				.css({ padding: '5px' })
				//.css({ 'max-height': (50*kX) + 'px', 'min-height': (33*kX) + 'px' })
				//.css({ height: Math.min(80, (32*kX + 10)) + "px" })
				.append(
						$('<img></img>')
							.attr('src', icon)
							.css({ width: (32*kX) + "px", height: (32*kX)+ "px", margin: "5px" })
				)
				.append(
						$('<p>' +app.name+ '</p>')
							.data('id', app.id)
							.data('name', app.name)
							.css({ margin: "5px", left: (32*kX + 20) + "px", position: "absolute", top: "5px", "font-size": (14*kX) + "px", "font-weight": "bold" })
				);
	if(kX != 1){
		li.css({ height: Math.min(80, (32*kX + 10)) + "px", 'min-height': Math.min(80, (32*kX + 10)) + "px" });
	}
	else{
		li.css({ height: "40px", "min-height": "40px" });
	}
	li.bind("click", function(e, ui){
		$.mobile.showPageLoadingMsg();
		appId = $(this).data('id');
		Log.AddActivity({ name: 'LoadAppFromPreview', params: [ { paramName: 'appId', paramValue: appId } ] });
		$("#content-body").empty();
		/*$("#content-body").append(
				$('<div id="map-canvas" style="width:500px; height:500px;"></div>')
		);*/
		$(".tab-icon").empty();
		$.mobile.changePage($("#mainscreen"));
		return false;
	})
	return li;
}
