/**
 * Browser Button
 */

var BrowserButton = {
		type: 'BrowserButton',
		drawControl: function(control, tab){
			var screenId = 'browser-screen-'+tab.tabId + '-' + GS.S4();
			var tabDiv = $("#"+tab.tabType+"-"+tab.tabId);
			var screen = $('<div></div>')
							.attr('id', screenId)
							.css({display:'none', height: GS.screenY + 'px'})
							.addClass('child-screen');
			
			var imageUrl = control.imageUrl;			
			var	ctrlDiv = $('<img></img>')
								.attr('src', imageUrl)
								.addClass('control-button')
								.data('control', control)
								.data('tabId', tab.tabId)
								.data('screenId', screenId)
								.data('tabScreen', tab.tabType + "-" + tab.tabId)
								.css({width: control.frame.width+'px', 
									height: control.frame.height+'px',
									position: 'absolute',
									top: control.frame.top+'px',
									left: control.frame.left+'px',
									margin: '0px',
									'font-size': '10px'});

			
			if(control.html !== undefined){
				/*if(control.html.indexOf('<html>') == 0){
					var content = control.html.split("<body>")[1].split("</body>")[0];
					screen.append(content
							//$('<iframe>' + control.html + '</iframe>')
					);
				}
				else{
					screen.append(control.html);
				}
				ctrlDiv
					.click(function(){
						$($("#" + $(this).data('tabScreen')).children()[0]).css({height: GS.screenY + 'px'});
						$("#" + $(this).data('screenId')).css({display:'block'});
						GS.showBackBtn();
						BackStack.down({ screenId: $(this).data('screenId') });
						return false;
					});*/
				ctrlDiv.click(function(){
					if(window.Ext !== undefined){
						window.Ext.ShowHtmlPage(control.html);
					}
				});
			}
			if(control.url !== undefined){
				//window.Ext.ShowWebPage(control.url);
				/*if(window.device !== undefined){
					if(window.device.version.indexOf("3.0") >= 0){
						var iframe = $('<iframe onload="resizeIframeToFitContent(this)"></iframe>')
										.attr('id', screenId + '-frame')
										.attr('src', control.url)
										.attr('width', '100%')
										.attr('height', GS.screenY + 'px')
										.load(function(){
											//alert('frame load');
										});
										//.css({width:'100%', height: GS.screenY + 'px'});
						screen.append(iframe);
						ctrlDiv
							.click(function(){
								$($("#" + $(this).data('tabScreen')).children()[0]).css({height: GS.screenY + 'px'});
								$("#" + $(this).data('screenId')).css({display:'block'});
								GS.showBackBtn();
								GS.BackBtn
								//.unbind('click')
								.data('screenid', $(this).data('screenId'))
								.click(function(){
									$("#"+$(this).data('screenid')).css({display:'none'});
									GS.hideBackBtn();
								})
								return false;
							});
					}
				}*/
			}

			if(control.html !== undefined){
				tabDiv.append(ctrlDiv);
			}
			else{
				tabDiv.append(
						$('<a></a>')
							.append(ctrlDiv)
							.attr('href', control.url)
							.data('url', control.url)
							.click(function(){
								var url = $(this).data('url');
								window.Ext.ShowWebPage(url);
								return false;
							})
						);
			}
			tabDiv.append(screen);
		}
}

function resizeIframeToFitContent(iframe) {
    // This function resizes an IFrame object
    // to fit its content.
    // The IFrame tag must have a unique ID attribute.
    //iframe.height = iframe.contentWindow.document.body.scrollHeight + 'px'; //document.frames[iframe.id].document.body.scrollHeight;
	window.setTimeout(function(frame){
		frame.clientHeight = '1024';
	}, 3000, iframe); 
}