/**
 * Search tab
 */

var Search = {
				type: 'Search',
				GetScreen:function(tab){
					var div= $("#"+ tab.tabType+'-'+tab.tabId);
					$('#search-panel-'+tab.tabId).remove();
					var scrDiv = $('<div></div>')
									//.css({ 'padding':'15px' })
									.attr('id', 'search-panel-'+tab.tabId);
					$("#online-switch-" + tab.tabId).remove();
					var searchBarDiv = $('<div></div>')
						.css({ 'padding':'15px' })
						.addClass('search-ui');
					
					var onlineSwitch = $('<div data-role="fieldcontain">' +
											'<label for="web-slider-' + tab.tabId + '">Web search</label>' +
											'<select style="width:50px" name="slider" id="web-slider-' + tab.tabId + '" data-role="slider">' +
												'<option value="off">Off</option>' +
												'<option value="on">On</option>' +
											'</select>' +
										'</div>')
											.attr('id', 'online-switch-' + tab.tabId)
											.addClass('search-ui')
											.data('tabId', tab.tabId)
											.data('tab', tab)
											.change(function(){
												var index = $("#web-slider-"+$(this).data('tabId'))[0].selectedIndex;
												if(index == 0){
													Search.drawBusinessWebResults($(this).data('tab'), 'business');
												}else{
													Search.drawBusinessWebResults($(this).data('tab'), 'site');
												}
											});

					var searchBar = $('<div data-role="fieldcontain">'+
									    '<label for="search-bar-' + tab.tabId + '">Search Input:</label><br/>'+
									    '<input type="search" name="password" id="search-bar-' + tab.tabId + '" value="" class="form-search" />'+
									'</div>')
									.addClass('search-ui');
					
					var searchBtn = $("<a>Search</a>")
										.attr("data-role", "button")
										.attr('href', '#')
										.data('id', tab.tabId)
										.data('tab', tab)
										.css({width: '100px', 
											height: '50px',
											//position: 'absolute',
											//top: control.frame.top+'px',
											//left: control.frame.left+'px',
											margin: '0px',
											'font-size': '16px'})
										.addClass('search-ui')
										.addClass('btn-fix-search')
										.click(function(){
											if($("#web-slider-"+$(this).data('id')).length > 0){
												var index = $("#web-slider-"+$(this).data('id'))[0].selectedIndex;
												if(index == 0){
													Search.drawBusinessWebResults($(this).data('tab'), 'business');
												}else{
													Search.drawBusinessWebResults($(this).data('tab'), 'site');
												}
											}
											else{
												if(tab.searchType == 'business'){
													Search.drawBusinessWebResults($(this).data('tab'), 'business');
												}
												else{
													Search.drawBusinessWebResults($(this).data('tab'), 'site');
												}
											}
										});
					
					if(tab.showSearchBar == 'Yes' || tab.searchType == 'website'){
						searchBarDiv.append(searchBar);
					}
					if(tab.showOnlineSwitch == 'Yes'){
						searchBarDiv.append(onlineSwitch);
					}
					if(tab.showSearchBar == 'Yes' || tab.searchType == 'website'){
						searchBarDiv.append(searchBtn);
					}
					
					//Find physical stores with predefined query string
					if(tab.showOnlineSwitch == 'No' && tab.showSearchBar == 'No'){
						scrDiv.css({padding:'0px',width:'0px',height:'0px'});
						Search.drawBusinessWebResults(tab, 'business');
						}
					
					//Find results on websites
					if(tab.searchType == 'website'){
						searchBtn.unbind('click');
						searchBtn
						.data('tabId', tab.tabId)
						.data('tab', tab)
						.click(function(){
							Search.drawBusinessWebResults($(this).data('tab'), 'site');
						});
					}
					
					//Find results for predefine search string for website/physical stores
					if(tab.searchType == "business" && tab.showOnlineSwitch == 'Yes' && tab.showSearchBar == 'No'){
						this.drawBusinessWebResults(tab, 'business');
					}
					
					scrDiv.append(searchBarDiv);
					
					div.append(scrDiv);
				},
				drawBusinessWebResults: function(tab, type){
					//scrDiv.css({padding:'0px',width:'0px',height:'0px', 'margin-top':'100px'});
					//show search results
					$.mobile.showPageLoadingMsg();
					var query = tab.searchRestrictionText;
					if($("#search-bar-"+tab.tabId).length > 0){
						query = $("#search-bar-"+tab.tabId).val();
					}
					var url = "";
					$('#search-list-' + tab.tabId).remove();
					if(type=='business') {
						if(GS.location != null){
							$("#search-list-"+tab.tabId).remove();
							/*var urlGet = GS.snappiiUrl + '/handlers/appbuilder.ashx?type=getPhysStores' +
					                    '&latitude=' + GS.location.latitude +
					                    '&longitude=' + GS.location.longitude +
					                    '&query=' + query +
					                    '&start=0' +
					                    '&format=json';*/
							url = GS.googleAPIUrl + 
									"?start=0"+
									"&key="+GS.googleAPIKey+
									"&v="+"1.0"+
									"&sll="+GS.location.latitude+","+GS.location.longitude+
									"&rsz="+"large"+
									"&q="+escape(query);
						}
						else{
							url = GS.googleAPIUrl + 
									"?start=0"+
									"&key="+GS.googleAPIKey+
									"&v="+"1.0"+
									"&sll=51.5,0.0"+
									"&rsz="+"large"+
									"&q="+escape(query);
						}
						$.mobile.showPageLoadingMsg();	
						$.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(url), 
					    		function (data, status){
					    		//alert("Status: " + status);
					    		if(status == 'success'){
					    			//alert('success');
					    			var rawJson = unescape(proxy_resp.content);
					    			var json = eval("(" + rawJson + ")");
					    			var ul = $('<ul data-role="listview" class="ui-scrollview-view ui-listview" id="search-list-' + tab.tabId + '"></ul>');
					    			ul.addClass('rss-ul').css({'margin':'0px'});
					    			for(var i=0; i<json.responseData.results.length; i++){
					    				ul.append(Search.drawPhysSearchItem(json.responseData.results[i], tab, i));
					    			}
					    			$('#search-results-' + tab.tabId).remove();
					    			$($('#search-panel-'+tab.tabId).children()[0]).append(
					    						$('<div></div>')
					    							.attr('id', 'search-results-' + tab.tabId)
					    							.css({ height: (47 * json.responseData.results.length) + 'px', 'margin-left': '-20px' })
					    							.append(ul)
					    					);
					    			ul.listview();
					    		}
					    		$.mobile.hidePageLoadingMsg();
						});
					} 
					else {
						var googleQuery = query;
						if(tab.websiteUrl !== undefined){
							googleQuery = query + " site:" + tab.websiteUrl;
						}
						if(window.Ext !== undefined){
							var rawStores = window.Ext.GetOnlineStores(googleQuery);
							//alert(rawStores);
							var json = eval("(" + rawStores + ")");
			    			var ul = $('<ul data-role="listview" class="ui-listview" id="search-list-' + tab.tabId + '"></ul>');
			    			ul.css({ 'margin-top':'10px' });
			    			ul.addClass('rss-ul');
			    			for(var i=0; i<json.stores.length; i++){
			    				ul.append(Search.drawOnlineSearchItem(json.stores[i], tab, i));
			    			}
			    			$('#search-results-' + tab.tabId).remove();
			    			$($('#search-panel-'+tab.tabId).children()[0]).append(
		    						$('<div></div>')
		    							.attr('id', 'search-results-' + tab.tabId)
		    							.css({ height: (47 * json.stores.length) + 'px', 'margin-left': '-20px' })
		    							.append(ul)
		    					);
			    			ul.listview();
						}
						$.mobile.hidePageLoadingMsg();
						/*url = GS.googleSearchUrl+
									"?cat=gwd%2FTop%2FShopping" +
									"&num=10"+
									"&q="+escape(query)+
									"&start=0";
						var googleQuery = query;
						if(tab.websiteUrl !== undefined){
							googleQuery = query + " site:" + tab.websiteUrl;
						}
						var urlGet = GS.snappiiUrl + '/handlers/appbuilder.ashx?type=getOnlineStores' +
				                    '&query=' + escape(googleQuery)+
				                    '&start=0' +
				                    '&format=json';
						$.mobile.showPageLoadingMsg();
						$.getScript("http://snappii.com/proxy.ashx?convert=json&url=" + escape(urlGet), 
					    		function (data, status){
					    		//alert("Status: " + status);
					    		if(status == 'success'){
					    			var rawContent = unescape(proxy_resp.content);
					    			var json = eval("("+ rawContent +")");
					    			var ul = $('<ul data-role="listview" class="ui-listview" id="search-list-' + tab.tabId + '"></ul>');
					    			ul.css({ 'margin-top':'10px' });
					    			ul.addClass('rss-ul');
					    			for(var i=0;i<json.stores.store.length;i++){
					    				ul.append(Search.drawOnlineSearchItem(json.stores.store[i], tab, i));
					    			}
					    			$('#search-results-' + tab.tabId).remove();
					    			$($('#'+tab.tabType+'-'+tab.tabId).children()[0]).append(
				    						$('<div></div>')
				    							.attr('id', 'search-results-' + tab.tabId)
				    							.css({ height: (47 * json.stores.store.length) + 'px' })
				    							.append(ul)
				    					);
					    			ul.listview();
					    		}
					    		$.mobile.hidePageLoadingMsg();
					    });*/
					}
				},
				drawPhysSearchItem: function(item, tab, number){
					var li = $('<li></li>')
						.attr('data-theme', 'c')
						.addClass('ui-btn')
						.addClass('ui-li')
						.addClass('ui-btn-icon-right')
						.addClass('ui-btn-up-c')
						.css({width:'100%', 'height': '45px'})//.css({width:GS.screenX+'px'})
						.data('url',item.ddUrl)
						.data('itemId', tab.tabId+'-'+number)
						.click(function(){
							 $("#search-screen-"+$(this).data('itemId')).find('ul').listview();	
							 $("#search-screen-"+$(this).data('itemId')).css({display:'block'});
							 ScrollUp(tab.tabType+'-'+tab.tabId);
							 $("#" + tab.tabType + '-' + tab.tabId).css({ height: GS.screenY + 'px' })
								GS.showBackBtn();
							 	BackStack.down({ screenId: "search-screen-"+$(this).data('itemId') });
							 	/*GS.BackBtn
								//.unbind()
								.data('screenid', "search-screen-"+$(this).data('itemId'))
								.click(function(){
									$("#"+$(this).data('screenid')).css({display:'none'});
									GS.hideBackBtn();
								});
								*/
								return false;
						});
					$('#search-screen-' + tab.tabId+'-'+number).remove();
					var screen = $('<div></div>')
									.attr('id', 'search-screen-' + tab.tabId+'-'+number)
									.css({display:'none', top: '0'})
									.addClass('child-screen');
					var mapScreen = $('<div></div>')
									.attr('id', 'search-map-screen-' + tab.tabId+'-'+number)
									.css({display:'none', top: '0'})
									.addClass('child-screen')
									.append(
										$('<iframe src="' + GS.mapPageUrl + '" style="width:100%; height:' + GS.screenY + 'px"></iframe>')
									);
					var address = '';
					for(var i=0; i<item.addressLines.length;i++){
						address += (item.addressLines[i] + ' ');
					}
					var descriptionArea = $('<div></div>')
											.css({margin:'10px'})
											.append(
													$('<label>' + item.title + '</label>')
														.css({ color:'#F0F0F0', 'font-size':'16px' })
											)
											.append('<br/>')
											.append(
													$('<label>' + address + '</label>')
														.css({ color:'#F0F0F0', 'font-size':'16px' })
											);
					var twitterLink = "http://twitter.com/home?status=" + escape(item.title + "; " + address);
					var phone = ((item.phoneNumbers === undefined) ? '' : item.phoneNumbers[0].number);
					var actionList = $('<ul data-role="listview" data-inset="true" data-theme="d">'+
										((phone.length > 0) ? ('<li><a href="tel:' + phone + '">Call</a></li>') : '' ) +
										//'<li><a href="'+item.ddUrl+ '" target="_blank">Map and Direction</a></li>'+
										((phone.length > 0) ? ('<li><a href="tel:' + phone + '">Send SMS</a></li>') : '' ) +
										((item.email !== undefined) ? ('<li><a href="mailto:' + item.email + '">Send Email</a></li>') : '' ) +
										//'<li><a href="mailto:'+'">Reviews</a></li>'+
										((phone.length > 0) ? ('<li><a href="tel:' + phone + '">Add to Contacts</a></li>') : '' ) +
										//'<li><a href="#">Add to Favorites</a></li>'+
										'<li><a href="' + twitterLink + '">Add to Twitter</a></li>'+
										'<li><a href="http://facebook.com">Add to Facebook</a></li>'+
									 '</ul>');
					actionList.append(
							$('<li><a href="#">Add to Favorites</a></li>')
								.data('item', item)
								.click(function(){
									Favorites.AddToFavorites($(this).data('item'));
								})
					);
					actionList.append(
							$('<li><a href="#">Reviews</a></li>')
								.data('item', item)
								.data('review-screen','search-screen-' + tab.tabId + '-' + number + '-review-screen')
								.click(function(){
									$(".child-screen").css({ display: 'none' });
									BackStack.down({ screenId: $(this).data("review-screen") });
									$("#" + $(this).data("review-screen")).css({ display: 'block' });
									return false;
								})
					);
					actionList.append(
							$('<li><a href="#">Map and Direction</a></li>')
								.data('item', item)
								.data('map-screen','search-map-screen-' + tab.tabId+'-'+number)
								.click(function(){
									//Favorites.AddToFavorites($(this).data('item'));
									/*window.localStorage.setItem("map-center", GS.location.latitude+","+GS.location.longitude);
									window.localStorage.setItem("map-latitude", GS.location.latitude);
									window.localStorage.setItem("map-longitude", GS.location.longitude);
									window.localStorage.setItem("map-height", GS.screenY - 250);
					    			var markersJson = "{ 'markers': [" + JSON.stringify(item) + "]}";
					    			window.localStorage.setItem("map-markers", markersJson);
					    			$("#" + $(this).data("map-screen")).find('iframe')[0].contentDocument.location.reload(true);
									$(".child-screen").css({ display: 'none' });
									$("#" + $(this).data("map-screen")).css({ display: 'block' });
									GS.showBackBtn();
								 	BackStack.down({ screenId: $(this).data("map-screen") });*/
									var markersJson = "{ 'markers': [" + JSON.stringify($(this).data('item')) + "]}";
									var mapUrl = GS.mapPageUrl + "?height=" + (GS.screenY - 250)+
													"&center=" + (GS.location.latitude+","+GS.location.longitude)+
													"&lat=" + GS.location.latitude +
													"&lng=" + GS.location.longitude +
													"&markers=" + escape(markersJson);
									if(window.Ext !== undefined){
										//window.Ext.ShowWebPage(mapUrl);
										window.location = mapUrl;
									}
								})
					);
					screen.append(descriptionArea).append(actionList);					
					
					var reviewDiv = Review.GetReviewsScreen(item, $("#"+ tab.tabType+'-'+tab.tabId), 'search-screen-' + tab.tabId+'-'+number);
					$("#"+ tab.tabType+'-'+tab.tabId)
						.append(screen)
						.append(mapScreen)
						.append(reviewDiv);
					Review.GetReviews(reviewDiv, item);
					
					$("#"+ tab.tabType+'-'+tab.tabId).append(screen).append(mapScreen);
					var width = '100%'; //(GS.screenX - 40)+'px'
					var header = $('<h3>'+item.title+'</h3>')
								.css({'font-size':'12px', 'margin-left': '10px', 'margin-bottom': '5px', 'margin-top': '5px', 'width':width});
					var description = $('<p>' + item.streetAddress + '</p>')
								.css({'font-size':'12px', 'margin-left': '10px', 'margin-bottom': '5px', 'margin-top': '5px', 'font-weight':'normal', 'width':width});
					var arrow = $('<span class="ui-icon ui-icon-arrow-r"></span>').css({right: '50px'});
					li.append(header).append(description).append(arrow);
					return li;
				},
				onOpen: function(tab){
					$("#Search-" + tab.tabId).css({display: 'block', height: '100%', width: '100%'});
					$("#search-panel-" + tab.tabId).css({display: 'block', height: '100%', width: '100%'});
					$("#" + tab.tabType + "-" + tab.tabId).find(".child-screen").css({display: 'none'});
					$("#" + tab.tabType + "-" + tab.tabId).find(".search-ui").css({display: 'block'});
				},
				drawOnlineSearchItem: function(item, tab, number){
					var li = $('<li></li>')
					.attr('data-theme', 'c')
					.addClass('ui-btn')
					.addClass('ui-li')
					.addClass('ui-btn-icon-right')
					.addClass('ui-btn-up-c')
					.css({ 'margin-left':'15px', 'height': '45px' })
					.css({width:GS.screenX+'px'})
					.data('url',item.url)
					.data('itemId', tab.tabId+'-'+number)
					.click(function(){
						 $("#search-screen-"+$(this).data('itemId')).find('ul').listview();
						 $("#search-screen-"+$(this).data('itemId')).css({display:'block'});
						 ScrollUp(tab.tabType+'-'+tab.tabId);
						 $("#" + tab.tabType + '-' + tab.tabId).css({ height: GS.screenY + 'px' })
							GS.showBackBtn();
						 	BackStack.down({ screenId: "search-screen-"+$(this).data('itemId') });
							/*GS.BackBtn
							//.unbind()
							.data('screenid', "search-screen-"+$(this).data('itemId'))
							.click(function(){
								$("#"+$(this).data('screenid')).css({display:'none'});
								GS.hideBackBtn();
							});*/
							return false;
					});
			    var url = item.url;
			    if(url.indexOf('http')<0){
			    	url = 'http://' + url;
			    }
				$('#search-screen-' + tab.tabId+'-'+number).remove();
				var screen = $('<div></div>')
								.attr('id', 'search-screen-' + tab.tabId+'-'+number)
								.css({display:'none', top: '0px'})
								.addClass('child-screen');

				$("#"+ tab.tabType+'-'+tab.tabId).append(screen);
				var width = '100%'; //(GS.screenX - 40)+'px'
				var header = $('<h3>'+item.headline+'</h3>')
							.css({'font-size':'12px', 'margin-left': '10px', 'margin-bottom': '5px', 'margin-top': '5px', 'width':width});
				var twitterLink = "http://twitter.com/home?status=" + escape(item.headline + "; " + url);
				var actionList = $('<ul data-role="listview" data-inset="true" data-theme="d">'+
									'<li><a href="'+ url+ '">Check site</a></li>'+
									//'<li><a href="#">Reviews</a></li>'+
									//'<li><a href="#">Add to Favorites</a></li>'+
									'<li><a href="' + twitterLink + '">Add to Twitter</a></li>'+
									'<li><a href="http://facebook.com">Add to Facebook</a></li>'+
								 '</ul>');
				actionList.append(
						$('<li><a href="#">Reviews</a></li>')
							.data('item', item)
							.data('review-screen','search-screen-' + tab.tabId + '-' + number + '-review-screen')
							.click(function(){
								$(".child-screen").css({ display: 'none' });
								BackStack.down({ screenId: $(this).data("review-screen") });
								$("#" + $(this).data("review-screen")).css({ display: 'block' });
								return false;
							})
				);
				actionList.append(
						$('<li><a href="#">Add to Favorites</a></li>')
							.data('item', item)
							.click(function(){
								Favorites.AddToFavorites($(this).data('item'));
							})
				);
				var descriptionArea = $('<div></div>')
											.css({margin:'10px'})
											.append(
													$('<label>' + item.headline + '</label>')
														.css({ color:'#F0F0F0', 'font-size':'16px' })
											)
											.append('<br/>')
											.append(
													$('<label>' + item.description + '</label>')
														.css({ color:'#F0F0F0', 'font-size':'16px' })
											);
				var description = $('<p>' + item.description + '</p>')
									.css({'font-size':'12px', 'margin-left': '10px', 'margin-bottom': '5px', 'margin-top': '5px', 'font-weight':'normal', 'width':width});
				var arrow = $('<span class="ui-icon ui-icon-arrow-r"></span>').css({right: '50px'});
				
				var reviewDiv = Review.GetReviewsScreen(item, $("#"+ tab.tabType+'-'+tab.tabId), 'search-screen-' + tab.tabId+'-'+number);
				/*$("#"+ tab.tabType+'-'+tab.tabId)
						.append(screen)
						.append(mapScreen)
						.append(reviewDiv);*/
				screen.append(descriptionArea).append(actionList).append(reviewDiv);	
				Review.GetReviews(reviewDiv, item);
				
				
				li.append(header).append(description).append(arrow);
				return li;
				}
			}