/**
 * Submit Form Button
 */

var SubmitFormButton = {
						type: 'SubmitFormButton',
						drawControl: function(tab){
							if(tab.controls.length == 0){
								return;
							}
							var tabDiv = $("#"+tab.tabType+"-"+tab.tabId);
							$("#Submit-" + tab.tabType + "-" + tab.tabId).remove();
							var maxTop = 0;
							for(var i=0; i<tab.controls.length; i++){
								var ctrl = tab.controls[i];
								if(parseInt(ctrl.frame.top) + parseInt(ctrl.frame.height) >  maxTop){
									maxTop = parseInt(ctrl.frame.top) + parseInt(ctrl.frame.height) + 50;
								}
							}
							$($("#"+tab.tabType+"-"+tab.tabId).children()[0]).css({height: (maxTop+200)+'px'});
							var kX = GS.screenX/320;
							var button = $("<a>Submit</a>")
											.attr("data-role", "button")
											.attr('href', '#')
											.attr('id', "Submit-" + tab.tabType+"-"+tab.tabId)
											.data('id', tab.tabId)
											.data('tab', tab)
											.data('formId', tab.formId)
											.css({width: (120*kX) + 'px', 
												//height: '50px',
												position: 'absolute',
												top: maxTop + 'px',
												left: ((GS.screenX - (120*kX))/2) +'px',
												margin: '0px',
												'font-size': (16*kX) + 'px'})
											.click(function(){
												var dataJson = '{ "data": [';
												var elements = $("#"+tab.tabType+"-"+tab.tabId).find('.input-field');
												
												//check required fields
												var isChecked = true;
												var fields = "";
												for(var i=0; i<elements.length;i++){
													var required = $(elements[i]).data('required');
													if(required == '1'){
														if ($(elements[i]).val() == null || $(elements[i]).val() == "" ){
															isChecked = false;
															//fields += ""
														}
													}
												}
												if(isChecked == false){
													alert("Some form fields are empty.");
													return;
												}
												
												for(var i=0; i<elements.length;i++){
													var id = $(elements[i]).data('controlId');
													var val = $(elements[i]).val();
													dataJson += ( '{"controlId":"'+id+'", "value":"' + val + '"}' );
													if(i!=elements.length-1){
														dataJson+=", ";
													}
												}
												dataJson += ']}';
												var url = GS.processorUrl + "/RequestProcessor.ashx?cmd=submitForm"	+
															"&appDbId=" + appId +
															"&formId=" + $(this).data('formId') +
															"&email=" + ((GS.user === undefined) ? "No email" : GS.user.email) +
															"&data=" + escape(dataJson);
												
												if(window.Ext !== undefined){
													url = window.Ext.GetSubmitFormUrl(GS.processorUrl, appId, 
																						$(this).data('formId'), 
																						((GS.user === undefined) ? "No email" : GS.user.email),
																						dataJson);
												}
												$.getScript(url, //"http://snappii.com/proxy.ashx?convert=json&url=" + escape(urlGet), 
											    		function (data, status){
											    		//alert("Status: " + status);
											    		if(status == 'success'){
											    			//
											    			alert("Your data was submitted successfully.")
											    		}
											    });
												//dataJson.set();
											});
							tabDiv.append(button);
						}
					}