/**
 * Global Settings for Application
 */
var GS = {
		splashsreen:'http://storage.store2phone.com/temp/snappiiSplash.png',
		splashscreentimer:10,
		processorUrl:'http://processor.store2phone.com',
		snappiiUrl:'http://www.snappii.com',
		snappiiProxyTool: "http://www.snappii.com/proxy.ashx?convert=json&cdata=false",
		mapPageUrl: 'http://storage.store2phone.com/www/map.html', // "map.html", //
		screenX: 320, //function(){return Math.min();}, 
		screenY: 480, // function(){}, 
		guid: function() {
	        return (this.S4() + this.S4() + "-" + this.S4() + "-" + this.S4() + "-" + this.S4() + "-" + this.S4() + this.S4() + this.S4());
	    },
	    S4: function() {
	        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
	    },
	    showBackBtn: function(){
	    	$("#back-btn").css({display:'block'});
	    },
	    hideBackBtn: function(){
	    	$("#back-btn").css({display:'none'});
	    },
	    BackBtn:$("#back-btn"),
	    user: null,
	    location: { latitude: 43.71, longitude: -74.00 },
	    getLocation: function(){
	    	var storedLtd = window.localStorage.getItem("my-latitude");
			var storedLng = window.localStorage.getItem("my-longitude");
			
			if(storedLtd == null || storedLng == null){
		    	navigator.geolocation.getCurrentPosition(function(position){ 
		    		GS.location = position.coords;
		    		getFromGPS = true;
		    		//alert('Location success');
					init();
					loadAppSettings(appId);
					currentLoc = GS.location.latitude + ", " + GS.location.longitude;
					window.localStorage.setItem("my-latitude", GS.location.latitude);
					window.localStorage.setItem("my-longitude", GS.location.longitude);
					Log.WriteLog("Location success. Latitude: "+GS.location.latitude + ", " + GS.location.longitude);
		    	}, function(error){
		    		//alert('Location fail');
		    		getFromGPS = false;
					init();
					//LocatorDialog.showDialog();
					loadAppSettings(appId);
					currentLoc = 'New York';
					Log.WriteLog("GPS location failed.");
		    	},
		    	{ maximumAge: 300000, timeout: 5000, enableHighAccuracy: true });
			}
			else{
				GS.location = { latitude: storedLtd, longitude: storedLng };
				init();
				loadAppSettings(appId);
				currentLoc = GS.location.latitude + ", " + GS.location.longitude;
				Log.WriteLog("Location success loaded from settings. Latitude: "+GS.location.latitude + ", " + GS.location.longitude);
			}
	    },
	    deviceID: null,
	    googleAPIUrl: "http://ajax.googleapis.com/ajax/services/search/local",
	    googleAPIKey: "ABQIAAAAo5Zw5FJzKRxpW8A6Ks0RjRQrWhMDmV1ZNSixHQoREgfFt5prcBSMSgu67JG2KM-MD7GJOmrUE9r65A",
	    googleSearchUrl: "http://www.google.com/search",
	    countryList: null,
	    getDeviceInfo: function(){
	    	if(window.device !== undefined){
	    		if(window.device.version.indexOf("2.2")>0){
	    			GS.snappiiProxyTool += "&cdata=false";
	    		}
	    		Log.writeDeviceStat();
	    	}
	    	else{
	    		return "From web browser";
	    	}
	    },
	    checkFirstStart: function(){
	    	//Check app status
	    	var check = window.localStorage.getItem("isFirstStart");
	    	if(check == null || check == ''){
	    		window.localStorage.setItem("isFirstStart", 'false');
	    		Log.AddActivity({ name: 'FirstRunAfterInstall', params: [ { paramName: 'time', paramValue: GS.DateFormat((new Date())) } ] });
	    	}
	    },
	    clickTabActivity: function(tab){
	    	Log.AddActivity({ name: 'ClickedTab', params: [ { paramName: 'tabId', paramValue: tab.tabId } ] });
	    },
	    standardFontSize: 14,
	    S4: function() {
	        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
	    },
	    DateFormat: function(date){
	    	// 06/10/11 15:24:16 +00:00
	    	var format = (date.getMonth()+1) + '/' 
	    	+ date.getDate() + '/' 
	    	+ date.getFullYear() + ' ' 
	    	+ date.getHours() + ':' 
	    	+ date.getMinutes() + ':'
	    	+ date.getSeconds();
	    	return format;
	    },
	    getParam: function(param) {
		    var linkTo = '';
		    var x = location.search.substr(1).split("&")
		    for (var i = 0; i < x.length; i++) {
		        var y = x[i].split("=");
		        if (y[0] == param) {
		            linkTo = y[1];
		        }
		    }
		    return linkTo;
		},
		cutTabName: function(tabName){
			var name = tabName;
			var maxLength = (GS.screenX / 5) / 7;
			if(tabName.length <= maxLength) {
				name = tabName;
			}
			else{
				name = tabName.substring(0, maxLength-3) + "...";
			}
			return name;
		},
	    checkConnection: function() {
	    	if(navigator.network === undefined){
	    		return 1;
	    	}
	        var networkState = navigator.network.connection.type;
	        if(networkState == Connection.NONE){
	        	return 0;
	        }
	        else{
	        	return 1;
	        }
	    },
	    setProcessorUrl: function(url){
	    	if(url.indexOf("RequestProcessor.ashx") > 0){
	    		var cutUrl = url.replace("/RequestProcessor.ashx", "");
	    		GS.processorUrl = cutUrl;
	    	}
	    	else{
	    		GS.processorUrl = url;
	    	}
	    }
};

var appId = 4495;
var initStarted = false;
//var appId = '998';
var app = null;
var newApp = null;
var getFromGPS = false;
var currentLoc = '';
var lastActiveTabId = '';
var isViewer = false;