/**
 * Location dialog
 */

var Locator = {
		handlerUrl: 'http://keywordcompetitor.com/locationloader.ashx',
		geocoder: null,
		getCountries: function(callback){
		    $.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(Locator.handlerUrl), 
		    		function (data, status){
			    		//alert("Status: " + status);
			    		if(status == 'success'){
			    			callback(data);
			    		}
		    	 });
		},
		getRegions: function(countryCode, callback){
			var handlerUrl = Locator.handlerUrl + '?country=' + countryCode;
		    $.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(handlerUrl), 
		    		function (data, status){
			    		if(status == 'success'){
			    			callback(data);
			    		}
		    	 });
		},
		getCity: function(regionCode, callback){
			var handlerUrl = Locator.handlerUrl + '?region=' + regionCode;
		    $.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(handlerUrl), 
		    		function (data, status){
			    		if(status == 'success'){
			    			callback(data);
			    		}
		    	 });
		},
		loadCountries: function(){
			GS.countryList = CountriesData;
			/*Locator.getCountries(function(data){
				GS.countryList = CountriesData;
			});*/
		},
		getCoordinates: function(address) {
			var url = "http://maps.google.com/maps/geo"+
						"?key=ABQIAAAAo5Zw5FJzKRxpW8A6Ks0RjRQrWhMDmV1ZNSixHQoREgfFt5prcBSMSgu67JG2KM-MD7GJOmrUE9r65A"+
						"&q=" + escape(address);
		    $.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(url), 
		    		function (data, status){
			    		if(status == 'success'){
			    			var rawJson = unescape(proxy_resp.content);
			    			var json = eval("("+rawJson+")");
			    			var position = json.Placemark[0].Point.coordinates;
			    			GS.location = {latitude:position[1], longitude:position[0]};
			    		}
		    	 });
			 /*if (Locator.geocoder == null) {
				 Locator.geocoder = new google.maps.Geocoder();
			 }
			 Locator.geocoder.geocode({ 'address': address }, function(result) {
                    var res = result;
                    var loc = res[0].geometry.location;
                    GS.location = {latitude:loc.Na, longitude:loc.Oa};
             });*/
		}
 
}

var LocatorDialog = {
			body: null,
			createBody: function(){
				$("#location-dialog").remove();
				$("#screen-content").append($('<div class="screen-view"></div>').attr('id', 'location-dialog'));				
				var body = $("#location-dialog");
				
				var countrySelector = $('<select></select>')
										.attr('data-native-menu',"false")
										.attr('id', 'country-selector')
										.attr('name', 'country-selector');
				for(var i=0; i<GS.countryList.length;i++){
					var country = GS.countryList[i];
					var option = $('<option value="' + country[0] + '">'+country[1]+'</option>');
					countrySelector.append(option);
				}
				countrySelector.change(function(){
					$.mobile.pageLoading();	
					Locator.getRegions($(this).val(), function(data){
						var rawJson = proxy_resp.content;
						var regionData = eval("("+ unescape(rawJson)+ ")");
						$("#region-selector").empty();
						for(var i=0; i<regionData.count; i++){
							var option = $('<option value="' + regionData.data[i].code + '">'+regionData.data[i].name+'</option>');
							$("#region-selector").append(option);
						}
						$('#region-selector').selectmenu('refresh');
						$("#city-selector").empty();
						$('#city-selector').selectmenu('refresh');
						$.mobile.pageLoading( true );
					})
				});
				body.append('<p>Current Position:</p>');
				body.append(countrySelector);
				body
					.css({
						display:'none', 
						'position': 'fixed', 
						//'top': '45px',
						'background': 'none repeat scroll 0 0 #F0F0F0',
					    'height': '100%',
					    'width': '100%',
					    'padding': '5px'
					});
				
				var regionSelector = $('<select></select>')
											.attr('data-native-menu',"false")
											.attr('id', 'region-selector')
											.attr('name', 'region-selector')
											.change(function(){
												Locator.getCity($(this).val(), function(data){
													var rawJson = proxy_resp.content;
													var regionData = eval("("+ unescape(rawJson)+ ")");
													$("#city-selector").empty();
													for(var i=0; i<regionData.count; i++){
														var option = $('<option value="' + regionData.data[i].code + '">'+regionData.data[i].name+'</option>');
														$("#city-selector").append(option);
													}
													$('#city-selector').selectmenu('refresh');
												})
											});

				var citySelector = $('<select></select>')
										.attr('data-native-menu',"false")
										.attr('id', 'city-selector')
										.attr('name', 'city-selector');
				
				var buttonsDiv = $('<div data-role="controlgroup"></div>')
									.css({ 'margin': '10px' })
									.attr("data-type", "horizontal");
				var btnOK = $('<a href="#" data-role="button">OK</a>')
								.css({width:'100px'})
								.click(function(){
									var address = "Russia, Ryazan";
									var country = $('#country-selector').val();
									var region = $('#region-selector').val();
									var city = $('#city-selector').val();
									Locator.getCoordinates(city);
									$("#location-dialog").css({ display: 'none' });
								});
				var btnCancel = $('<a href="#" data-role="button">Cancel</a>')
									.css({width:'100px'})
									.click(function(){
										$("#location-dialog").css({ display: 'none' });
									});
				buttonsDiv.append(btnOK).append(btnCancel);
				
				body
					.append(countrySelector)
					.append(regionSelector)
					.append(citySelector)
					.append(buttonsDiv);
				body
					.css({
						display:'none', 
						'position': 'fixed', 
						'top': '45px',
						'background': 'none repeat scroll 0 0 #F0F0F0',
						'height': '100%',
						'width': '100%'
					});
				
				//$("#location-dialog").remove();
				//$("#screen-content").append(body);
			},
			showDialog: function(){
				LocatorDialog.body.css({display:'block'});
			}
		}