/**
 * Render application
 */

function RenderApp(){
	//draw tabs
	Log.WriteLog("App Id" + appId + ". Tabs count: " + app.tabs.length);
	Settings.AddSettings();
	for(var i=0; i<app.tabs.length; i++){
		//Add tab screen
		$("#content-body").append(getTabScreen(app.tabs[i]));
		
		//render tab screens
		app.tabs[i] = Scale.scaleTab(app.tabs[i]);
		RenderTab(app.tabs[i]);
		Log.WriteLog("App Id" + appId + ". Render tab " + app.tabs[i].tabId + "; " + app.tabs[i].tabType);
		//add more button
		if(i==4){
			addMoreButton();
		}
		//draw tabs on tab bar
		if(i<4){
			$($("#tabbar-"+(i+1)).find('div')[0]).append(DrawTabIcon(app.tabs[i]));
		}
		else{
			//Draw tabs on more button screen
			$("#more-list").append(DrawTabMore(app.tabs[i]));
		}
		//$('#' + app.tabs[i].tabType + '-' + app.tabs[i].tabId).page();
	}
	$('a[data-role="button"][class!="ui-btn-right"]').addClass('btn-fix');
	//$('.btn-fix').refresh();
	/*$.each($(".screen-view"), function(i, tab){
		$(tab).find('div').page();
	});*/
	$.each($('.datetime-field'), function(i, tab){
		var control = $(tab).data('control');
		$(tab).css({
			top: control.frame.top+'px',
			left: control.frame.left+'px'
		});
	});
	$.each($('.input-field'), function(i, tab){
		var control = $(tab).data('control');
		$(tab).css({
			height: control.frame.height+'px',
			top: control.frame.top + 'px',
			left: control.frame.left + 'px',
			width: control.frame.width + 'px'
		});
	});
	$.each($('.input-text-field'), function(i, tab){
		var control = $(tab).data('control');
		$(tab).css({
			height: control.frame.height+'px'
		});
	});
	scrollInit(0);
	//scrollInitDatetime(0);
	$("#content-body").find('div').page();
	$("#more-list").listview();
	$('a.ui-btn-right[data-role="button"]').removeClass('btn-fix');
	$('a.ui-btn-left[data-role="button"]').removeClass('btn-fix');
	$('.control-button').click(function(){
		var ctrl = $(this).data('control');
		switch(ctrl.controlType){
		case 'CallButton': 
			Log.AddActivity({ name: 'clickedCallButton', params: [ { paramName: 'phone', paramValue: ctrl.phoneNumber } ] });
			break;
		default:
			Log.AddActivity({ name: 'ClickedButtonControl', params: [ { paramName: 'type', paramValue: ctrl.controlType } ] });
			break;
		}
	});
	//$("#content-body").css({})
	$($("#content-body").children()[0]).css({height: GS.screenY + 'px', display: 'block'});
	$(".child-screen").find("div .ui-body-c").css({ background: 'transparent' });
	$(".child-screen").find('input').css({ display: 'block !important' });
	$(".custom-tab").find(".ui-page").css({ display: 'block' });
	$(".child-screen").find(".ui-page").css({ display: 'block' });
	$(".form-input ").css({ width: (GS.screenX - 80) + 'px' });
	
}

function DrawTabIcon(tab){
	var name = tab.tabName;
	var icon = (tab.tabType!='PoweredBy')?tab.tabImageUrl:'http://storage.store2phone.com/temp/app.png';
	var div = $('<div></div>')
				.data('id', tab.tabType + '-' + tab.tabId)
				.data('name', tab.tabName)
				.data('tab', tab)
				.append(
						$('<img></img>')
							.attr('src', icon)
				)
				.append(
						$('<p>' + GS.cutTabName(name) + '</p>')
				)
				.click(function(){
					GS.hideBackBtn();
					if(TypeWrapper[$(this).data('tab').tabType] != null){
						if(TypeWrapper[$(this).data('tab').tabType].onOpen !== undefined){
							TypeWrapper[$(this).data('tab').tabType].onOpen($(this).data('tab'));
						}
					}
					if($(this).data('tab').tabType == 'Browser'){
						if($(this).data('tab').html === undefined){
							var url = $(this).data('tab').url;
							window.Ext.ShowWebPage(url);
							return;
						}
						else{
							$('#browser-screen-'+$(this).data('tab').tabId).css({display:'block'});
						}
					}
					if($(this).data('tab').tabType == 'Custom'){
						if($(this).data('tab').controls.length == 1 && $(this).data('tab').controls[0].controlType == 'Video'){
							var url = $($(this).data('tab').controls[0].YouTubeEmbedCode).find('embed').attr('src');
							window.Ext.ShowWebPage(url);
							return;
						}
					}
					
					GS.clickTabActivity($(this).data('tab'));
					$('#save-settings-btn').css({display:'none'});
					$('.screen-view').css({display:'none'});
					
					$("#"+$(this).data('id')).css({display:'block'});
					$("#"+$(this).data('id')).find(".ui-scrollview-view").css({display:'block'});
					$("#"+$(this).data('id')).find(".ui-control-container").css({display:'block'});
					$("#header-text").text($(this).data('name'));
					$(".child-screen").css({display:'none'});
					$($(".form-search").parent()).css({ width: (GS.screenX - 100) + 'px' });
					lastActiveTabId = $(this).data('id');
					BackStack.root({ screenId: $(this).data('id')});

					//$("#"+$(this).data('id')).scrollTop = 0;
					//$($("#"+$(this).data('id')).children()[0]).scrollTop = 0;
					//$("#"+$(this).data('id')).scrollview("scrollTo", 0, 0, 10);
					//$('html, body').animate({scrollTop: '0px'}, 800);
					
					//$($("#"+$(this).data('id')).children()[0]).css({height: tempH});
					//$("#"+$(this).data('id')).css({height:'100%'});
					
					
					ScrollUp($(this).data('id'));

				});
	var a = $('<a></a>')
				.attr('rel','external');
	/*if(tab.tabType == 'Browser'){
		if(tab.html === undefined){
			a.attr('href', tab.url).append(div).css({ 'color':'#FFFFFF', 'text-decoration':'none' });
			return a;
		}
	}*/
	return div;
}

function ScrollUp(id) {
	$("#"+id).css({height:'0px'});
	$("#"+id).css({display:'none'});
	$("#"+id).css({height:'100%'});
	$('html, body').animate({scrollTop: '0px'}, 800);
	$("#"+id).css({display:'block'});
}

function DrawTabMore(tab){
	var kX = GS.screenX / 320;
	var icon = (tab.tabType!='PoweredBy') ? tab.tabImageUrl : 'http://storage.store2phone.com/temp/app.png';
	$("#more-list-item-" + tab.tabId).remove();
	//var li = ListItem.GetItem({color:'#E0E0E0'});
	return $('<li></li>')
				.attr('id', 'more-list-item-' + tab.tabId)
				.data('id', tab.tabType + '-' + tab.tabId)
				.data('name', tab.tabName)
				.data('tab', tab)
				.css({ 'max-height': '50px' })
				.click(function(){
					GS.hideBackBtn();
					if(TypeWrapper[$(this).data('tab').tabType] != null){
						if(TypeWrapper[$(this).data('tab').tabType].onOpen !== undefined){
							TypeWrapper[$(this).data('tab').tabType].onOpen($(this).data('tab'));
						}
					}
					if($(this).data('tab').tabType == 'Browser'){
						if($(this).data('tab').html === undefined){
							window.location = $(this).data('tab').url;
							return;
						}
						else{
							$('#browser-screen-'+$(this).data('tab').tabId).css({display:'block'});
						}
					}
					if($(this).data('tab').tabType == 'Custom'){
						if($(this).data('tab').controls.length == 1 && $(this).data('tab').controls[0].controlType == 'Video'){
							window.location = $($(this).data('tab').controls[0].YouTubeEmbedCode).find('embed').attr('src');
							return;
						}
					}
					GS.clickTabActivity($(this).data('tab'));
					$('.screen-view').css({display:'none'});
					$('#save-settings-btn').css({display:'none'});
					$("#"+$(this).data('id')).css({display:'block'});
					$("#more-list").find('li').removeClass('ui-btn-active');
					$("#header-text").text($(this).data('name'));
					$(".child-screen").css({display:'none'});
					lastActiveTabId = $(this).data('id');
					BackStack.root({ screenId: $(this).data('id')});
					return false;
				})
				.append(
						$('<img></img>')
							.attr('src', icon)
				)
				.append(
						$('<a href="#">' +tab.tabName+ '</a>')
							.data('id', tab.tabType + '-' + tab.tabId)
							.data('name', tab.tabName)
							.data('tab', tab)
							.css({ 'font-size' : '16px' })
							.click(function(){
								GS.hideBackBtn();
								if(TypeWrapper[$(this).data('tab').tabType] != null){
									if(TypeWrapper[$(this).data('tab').tabType].onOpen !== undefined){
										TypeWrapper[$(this).data('tab').tabType].onOpen($(this).data('tab'));
									}
								}
								if($(this).data('tab').tabType == 'Browser'){
									if($(this).data('tab').html === undefined){
										var url = $(this).data('tab').url;
										window.Ext.ShowWebPage(url);
										return;
									}
								}
								if($(this).data('tab').tabType == 'Custom'){
									if($(this).data('tab').controls.length == 1 && $(this).data('tab').controls[0].controlType == 'Video'){
										var url = $($(this).data('tab').controls[0].YouTubeEmbedCode).find('embed').attr('src');
										window.Ext.ShowWebPage(url);
										return;
									}
								}
								/*$('.screen-view').css({display:'none'});
								$("#"+$(this).data('id')).css({display:'block'});
								$("#more-list").find('li').removeClass('ui-btn-active');
								$("#header-text").text($(this).data('name'));
								$(".child-screen").css({display:'none'});*/
								$('.screen-view').css({display:'none'});
								$('#save-settings-btn').css({display:'none'});
								$("#"+$(this).data('id')).css({display:'block'});
								$("#more-list").find('li').removeClass('ui-btn-active');
								$("#header-text").text($(this).data('name'));
								$(".child-screen").css({display:'none'});
								lastActiveTabId = $(this).data('id');
								BackStack.root({ screenId: $(this).data('id')});
								return false;
							})
				);
}

function getTabScreen(tab){
	var tabType = tab.tabType;
	var div = $('<div></div>')
				.attr('id', tabType + '-' + tab.tabId)
				.css({display:'none'})
				.addClass('screen-view')
				.attr("data-scroll", "y");
	if(tabType == 'Custom' || tabType == 'Form'){
		div.addClass('custom-tab');
	}
	return div;
	/*switch(tabType){
	case "Custom": break;
	case "Community
	}*/
}

function RenderTab(tab){
	var tabType = tab.tabType;
	if(tabType=='RssReader'){
		RSS.GetScreen(tab);
	}
	if(tabType=='Browser'){
		Browser.GetScreen(tab);
	}
	if(tabType=='Deals'){
		Deals.GetScreen(tab);
	}
	if(tabType=='Community'){
		Discussion.GetScreen(tab);
	}
	if(tabType=='PoweredBy'){
		PoweredBy.GetScreen(tab);
	}
	if(tabType=='Search'){
		Search.GetScreen(tab);
	}
	if(tabType=='CustomList'){
		List.GetScreen(tab);
	}
	if(tabType=='Map'){
		Map.GetScreen(tab);
	}
	if(tabType == 'Nearby' || tabType == 'NearbyNoCategories'){
		Nearby.GetScreen(tab);
	}
	if(tabType == 'Form'){
		Log.WriteLog("Start Form control render");
		SubmitFormButton.drawControl(tab);
	}
	if(tabType == 'Favorites'){
		Favorites.GetScreen(tab);
	}
	if(tab.controls !== undefined){
		drawChildControls(tab.controls, tab);
	}
}

function drawChildControls(controls, tab){
	for(var i=0;i<controls.length;i++){
		var control = controls[i];
		Log.WriteLog("Render button: " + control.controlType);
		try{
			if(control.controlType == 'Image'){
				Image.drawControl(control, tab);
			}
			if(control.controlType == 'CallButton'){
				CallButton.drawControl(control, tab);
			}
			if(control.controlType == 'EmailButton'){
				EmailButton.drawControl(control, tab);
			}
			if(control.controlType == 'LoginButton'){
				LoginButton.drawControl(control, tab);
			}
			if(control.controlType == 'SignupButton'){
				SignupButton.drawControl(control, tab);
			}
			if(control.controlType == 'Label'){
				Label.drawControl(control, tab);
			}
			if(control.controlType == 'VideoButton'){
				VideoButton.drawControl(control, tab);
			}
			if(control.controlType == 'BrowserButton'){
				BrowserButton.drawControl(control, tab);
			}
			if(control.controlType == 'TextInput'){
				TextInput.drawControl(control, tab);
			}
			if(control.controlType == 'DatetimeInput'){
				DatetimeInput.drawControl(control, tab);
			}
			if(control.controlType == 'MultipleChoiceList'){
				MultipleChoiceList.drawControl(control, tab);
			}
			if(control.controlType == 'MapButton'){
				MapButton.drawControl(control, tab);
			}
			if(control.controlType == 'PhotoInput'){
				PhotoInput.drawControl(control, tab);
			}
			if(control.controlType == 'Video'){
				Video.drawControl(control, tab);
			}
			if(control.controlType == 'EmailPhotoButton'){
				EmailPhotoButton.drawControl(control, tab);
			}
			if(control.controlType == 'FormButton'){
				FormButton.drawControl(control, tab);
				var formTab = { tabType: 'FormButton', 
								tabId: control.formView.formId, 
								controls: control.formView.controls,
								formId: control.formView.formId };
				drawChildControls(control.formView.controls, formTab);
				SubmitFormButton.drawControl(formTab);
			}
		}
		catch(err){	  
			  var txt = "AppId: "+appId+ ". Error: " + err.name + "; " + err.message + "; " + err.description;
			  Log.WriteLog(txt);
		}
		
	}
}

function addMoreButton(){
	if(app.tabs.length<5){
		return;
	}
	var screenDiv = $('<div></div>')
					.attr('id', 'more-screen')
					.addClass('screen-view')
					.attr("data-scroll", "y")
					.append(
							'<ul id="more-list" data-role="listview" style="ui-li-icon"></ul>'
							);
	var tabDiv = $('<div></div>')
				.append(
						$('<img></img>')
							.attr('src', 'http://storage.store2phone.com/IconLibrary/Device/SnAPPii-toolbar icons-08.png')
				)
				.append(
						$('<p>More</p>')
				)
				.click(function(){
					$("#more-list").find('li').removeClass('ui-btn-active');
					$("#header-text").text('More');
					$('.screen-view').css({display:'none'});
					$("#more-screen").css({display:'block'});
				});
	
	$($("#tabbar-5").find('div')[0]).append(tabDiv);
	$("#content-body").append(screenDiv);
}

function RenderLocationControls(){
	for(var i=0; i < app.tabs.length; i++){
		if(app.tabs[i].tabType == "Search"){
			Search.GetScreen(app.tabs[i]);
		}
		if(app.tabs[i].tabType == "NearbyNoCategories" || app.tabs[i].tabType == 'Nearby'){
			Nearby.GetScreen(app.tabs[i]);
		}
	}
}