/**
 * List item
 */

var ListItem = {
		//settings = { color, forecolor, font-size, font-family, content }
		GetItem: function(settings, callback){
			var li = $('<li></li>').addClass('list-item');
			
			var liContent = '<div class="list-item-img"><div>';
							//'<label>Elite Acura</label>'+
							//'<p>538 Rte 38 E, Maple Shade, New Jersey, United S...</p>'+
							//'<img style="position: absolute; top: 25px; left: 300px;" src="images/table-arrow.png">';
			li.append(liContent);
			var color = (settings.color === undefined) ? '#E0E0E0' : settings.color;
			var forecolor = (settings.forecolor === undefined) ? '#202020' : settings.forecolor;
			var fontsize = (settings.fontsize === undefined) ? '14px' : settings.fontsize;
			var fontfamily = (settings.fontfamily === undefined) ? 'Helvetica,Arial,sans-serif' : settings.fontfamily;
			li.css({'background-color':color, 'color':forecolor, 'font-size':fontsize, 'font-family':fontfamily});
			if(settings.content !== undefined){
				li.append(settings.content);
			}
			if(callback !== undefined){
				li.click(function(){ callback(); })
			}
			return li;
		}
};