/**
 * Datetime Input
 */

var DatetimeInput = {
						type: 'DatetimeInput',
						drawControl: function(control, tab){
							var tabDiv = $("#"+tab.tabType+"-"+tab.tabId);
							var imageUrl = control.imageUrl;
							var inputId = 'datetime-input-' + control.controlId;
							$("#"+inputId).remove();
							var dataOptions = '{"mode": "datebox"}';
							if(control.format == 'datetime'){
								dataOptions = '{"mode": "slidebox", "dateFormat":"YYYY-MM-DDTGG:iiAA", "timeFormat":12, "fieldsOrder":["y","m","d","h","i"]}';
							}
							if(control.format == 'time'){
								dataOptions = '{"mode": "timebox", "timeFormat":24 }';
							}
							//var ctrlDiv = $('<input type="date" name="'+inputId+'" id="' + inputId + '" value=""  />')
							var ctrlDiv = 	$('<input name="'+inputId+'" id="' + inputId + '" type="text" ' +
															+ 'data-options=\'' + dataOptions + '\'' + 
															'/>')
															//.attr("data-options", '{"mode": "slidebox", "dateFormat":"YYYY-MM-DDTGG:iiAA", "timeFormat":12, "fieldsOrder":["y","m","d","h","i"]}')
															.addClass('input-field')
															.data('control', control)
															.data('controlId', control.controlId)
															.data('required', control.required)
															.css({
																//height: (control.frame.height * 0.8)+'px',
																'font-size': (control.frame.height/2) + 'px',
																'padding': '0px'
																//width: control.frame.width+'px'
																//top: control.frame.top+'px',
																//left: control.frame.left+'px',
																//position: 'absolute',
																//padding: '0px'
															})
															.click(function(){});
															/*.mousedown(function(){
																//dateTimeSet.element = $(this);
																//$('#datepicker').css({visibility:'visible'});
															})
															.blur(function(){
																//$('#datepicker').css({visibility:'hidden'});
															});*/
							var container = $('<div></div>')
												.attr('id', 'container-'+inputId)
												.addClass('datetime-field')
												.addClass('ui-control-container')
												.data('control', control)
												.css({
														height: (control.frame.height * 0.95)+'px',
														width: control.frame.width+'px',
														top: (control.frame.top * 0.99)+'px !important',
														left: control.frame.left+'px !important',
														position: 'absolute',
														padding: '0px',
														'max-height': control.frame.height+'px',
														'min-height': '0px'
													});

							//var label = $('<label for='+inputId+'>-</label>');
							container.append(ctrlDiv);
							tabDiv.append(container);
							$("#datetime-input-" + control.controlId).datebox();
						}
					}