/**
 * Email Button
 */

var EmailButton = {
		type: 'EmailButton',
		drawControl: function(control, tab){
			var tabDiv = $("#"+tab.tabType+"-"+tab.tabId);
			var imageUrl = control.imageUrl;
			var ctrlDiv = $("<a>" + ((control.title !== undefined)?control.title:'') + "</a>")
							.attr("data-role", "button")
							.attr('href', 'mailto:'+control.emailAddress)
							.data('email', control.emailAddress)
							.addClass('control-button')
							.data('control', control)
							.css({width: control.frame.width+'px', 
								height: control.frame.height+'px',
								position: 'absolute',
								top: control.frame.top+'px',
								left: control.frame.left+'px',
								margin: '0px',
								'font-size': '14px'})
							.click(function(){
								//return false;
							});
			if(imageUrl !== undefined){
				ctrlDiv = $('<img></img>')
								.attr('src', imageUrl)
								.data('email', control.emailAddress)
								.css({width: control.frame.width+'px', 
									height: control.frame.height+'px',
									position: 'absolute',
									top: control.frame.top+'px',
									left: control.frame.left+'px',
									margin: '0px',
									'font-size': '10px'})
								.click(function(){
									window.location = "mailto:" + $(this).data('email');
									//return false;
								});
					
			}
			tabDiv.append(ctrlDiv);
		}
}