/**
 * Load app settings from Snappii server
 */

function loadAppSettings(appId){
	var kX = GS.screenX / 320;
	GS.standardFontSize = 14 * kX;
	$.mobile.showPageLoadingMsg();
	var storedConfig = window.localStorage.getItem("app-config");
	Log.WriteLog("Start app loading...");
	/*if(storedConfig == null && isViewer == false){
		Log.WriteLog("Loading from stored config...");
		if(window.Ext !== undefined){				
			var decryptConfig = window.Ext.DecryptConfig();
			app = eval("(" + decryptConfig + ")");
		}
		else{
			if (config !== undefined && config != null){
				app = config;
			}
		}
		GS.setProcessorUrl(app.requestProcessorUrl);
		window.localStorage.setItem("app-config", JSON.stringify(app));
		$("content-body").css({ height: GS.screenY + 'px' });
		RenderApp();
		if(app.tabs[0].tabType == "Map" || app.tabs[0].tabType == "Browser" ){
		}
		else {
			$("#tabbar-1").find('div').trigger('click');
		}
		$.mobile.hidePageLoadingMsg();
	}*/
		Log.WriteLog("Loading from server...");
		app = eval("(" + storedConfig + ")");
		if(window.Ext !== undefined && isViewer == false){
			//if app on device - load app from config
			Log.WriteLog("Loading config from local file");
			var decryptConfig = window.Ext.DecryptConfig();
			var appFromConfig = eval("(" + decryptConfig + ")");
			
			if(app != null){
				//check config version from binary and cache
				if(appFromConfig.appVersion > app.appVersion){
					//for start new version from Market
					app = appFromConfig;
				}
			}
			else{
				//for first app start
				app = appFromConfig;
			}
			
		}
		var iTunesVersion = "1.0.0";
		if(app != null){
			iTunesVersion = app.iTunesVersion;
			if(iTunesVersion == ""){
				iTunesVersion = "1.0.0";
			}
		}
		var appVersion = "1";
		if(app != null){
			appVersion = app.appVersion;
		}
		var uploadUrl = "";
		if(window.Ext === undefined){
			//for web version
			uploadUrl = GS.processorUrl + "/RequestProcessor.ashx?cmd=getAppConfigExt&appDbId=" + appId + "&appVersion=" + appVersion + "&iTunesVersion=" + iTunesVersion + "&platform=2";
		}
		else{
			uploadUrl = window.Ext.GetConfigUrl(GS.processorUrl, appId, appVersion, iTunesVersion, isViewer);
		}
		$.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(uploadUrl), 
	    		function (data, status){
	    		//alert("Status: " + status + ", data: " + data);
	    		if(status == 'success'){
	    			var encryptXml = unescape(proxy_resp.content);
	    			//check to error
	    			if(encryptXml.indexOf("error") >= 0){
	    				var errorDoc = $.parseXML(encryptXml);
	    				var code = $(errorDoc).find('code').text();
	    				Log.WriteLog("Get config error with code = " + code);
	    				if(code == "14"){
	    					navigator.notification.alert("New version of app is available on Android Market.", function(){
	    						//window.Ext.OpenMarket();
	    					}, "Information", "OK")
	    				}
	    				if(code == "13"){
	    					//alert("no reload app");
	    				}
	    				if(code == "2"){
	    					alert("Server maintainance in progress. Try again later.");
	    				}
	    			}
	    			else{
	    				//for device
	    				if(window.Ext !== undefined){
	    					//download new config
	    					var xml = window.Ext.Decrypt(unescape(encryptXml));
	    					var xmlDoc = $.parseXML(xml);
	    					var jsonTxt = $(xmlDoc).find('app').text();
	    					newApp = eval("(" + jsonTxt + ")");
	    					
	    					Log.WriteLog("Show new version message.");
	    				    navigator.notification.confirm(
	    				            'An updated version of this app is available. Load now?', 
	    				            function(button){
	    				            	if(button == 1){
		    				            	app = newApp;
		    				            	Log.WriteLog("Start apply of new config");
		    				            	GS.setProcessorUrl(app.requestProcessorUrl);
		    				    			window.localStorage.setItem("app-config", JSON.stringify(app));
		    				    			$("#content-body").empty();
		    				    			$(".tab-icon").empty();
		    				    			$("content-body").css({ height: GS.screenY + 'px' });
		    				    			RenderApp();
		    				    			
		    				    			if(app.tabs[0].tabType != "Map" && app.tabs[0].tabType != "Browser" ){
		    				    				$("#tabbar-1").find('div').trigger('click');
		    				    			}
	    				            	}
	    				            	else{
	    				            		return;
	    				            	}
	    				            },   
	    				            'Information',
	    				            'OK,Cancel' 
	    				        );	    					
	    				}
	    				else{
	    					var xmlDoc = $.parseXML(encryptXml);
	    					var jsonTxt = $(xmlDoc).find('app').text();
	    					app = eval("(" + jsonTxt + ")");
	    				}
	    			}
	    			GS.setProcessorUrl(app.requestProcessorUrl);
	    			window.localStorage.setItem("app-config", JSON.stringify(app));
	    			$("content-body").css({ height: GS.screenY + 'px' });
	    			RenderApp();
	    			
	    			if(app.tabs[0].tabType != "Map" && app.tabs[0].tabType != "Browser" ){
	    				$("#tabbar-1").find('div').trigger('click');
	    			}
	    		}
	    		$.mobile.hidePageLoadingMsg();
	    	 });
}