function ResizePageContentHeight(page)
{
	var $page = $(page);
	var $content = $page.children(".ui-content");
	var hh = $page.children(".ui-header").outerHeight(); hh = hh ? hh : 0;
	var fh = $page.children(".ui-footer").outerHeight(); fh = fh ? fh : 0;
	var pt = parseFloat($content.css("padding-top"));
	var pb = parseFloat($content.css("padding-bottom"));
	var wh = window.innerHeight;
	$content.height(wh - (hh + fh) - (pt + pb));
}

//$(":jqmData(role='page')").live("pageshow", function(){});

$(window).bind("orientationchange", function(event) {
	//ResizePageContentHeight($(".ui-page"));
});

function scrollInit(event) {
	//$("#content-body").overscroll();
	//return;
	
	var $page = $('#mainscreen'); //$(this);

	// For the demos that use this script, we want the content area of each
	// page to be scrollable in the 'y' direction.

	$page.find(".ui-content").attr("data-"+ $.mobile.ns +"scroll", "y");

	// This code that looks for [data-scroll] will eventually be folded
	// into the jqm page processing code when scrollview support is "official"
	// instead of "experimental".

	$page.find(":jqmData(scroll):not(.ui-scrollview-clip)").each(function(){
		var $this = $(this);
		// XXX: Remove this check for ui-scrolllistview once we've
		//      integrated list divider support into the main scrollview class.
		if ($this.hasClass("ui-scrolllistview")){
			$this.scrolllistview();
		}
		else
		{
			var st = $this.jqmData("scroll") + "";
			var paging = st && st.search(/^[xy]p$/) != -1;
			var dir = st && st.search(/^[xy]/) != -1 ? st.charAt(0) : null;

			var opts = {};
			if (dir)
				opts.direction = dir;
			if (paging)
				opts.pagingEnabled = true;

			var method = $this.jqmData("scroll-method");
			if (method)
				opts.scrollMethod = method;

			$this.scrollview(opts);
			var id = $this.attr('id');
			if(id !== undefined){
				$($this.children()[0]).css({height: 'auto'});
				if(id.indexOf('Custom-')>=0 || id.indexOf('Form-')>=0){
					//$($this.children()[0]).css({height: (GS.screenY-$("#footer").height()-$("#header").height()-10)+'px'});
					for (var i = 0; i < app.tabs.length; i++) {
						if (id.indexOf(app.tabs[i].tabId) >= 0) {
							if (app.tabs[i].controls.length > 0) {
								var maxBottom = parseInt(app.tabs[i].controls[0].frame.height) + parseInt(app.tabs[i].controls[0].frame.top);
								for (var j = 1; j < app.tabs[i].controls.length; j++) {
									if (parseInt(app.tabs[i].controls[j].frame.height) + parseInt(app.tabs[i].controls[j].frame.top) > maxBottom) {
										maxBottom = parseInt(app.tabs[i].controls[j].frame.height) + parseInt(app.tabs[i].controls[j].frame.top);
									}
								}
								if(id.indexOf('Form-')>=0){
									$($this.children()[0]).css({height: (maxBottom + 200) + 'px'});
								}
								else{
									//fix for signup screen on devices with low resolution
									$($this.children()[0]).css({height: (maxBottom + 200) + 'px'});
								}
							}
							break;
						}
					}
					//$this.css({height: GS.screenY+'px'});
				}
			}
		}
	});

	// For the demos, we want to make sure the page being shown has a content
	// area that is sized to fit completely within the viewport. This should
	// also handle the case where pages are loaded dynamically.

	ResizePageContentHeight(event.target);
}

function scrollInitDatetime(event) {
	var $page = $('#datepicker'); //$(this);

	// For the demos that use this script, we want the content area of each
	// page to be scrollable in the 'y' direction.

	$page.find(".ui-content").attr("data-"+ $.mobile.ns +"scroll", "y");

	// This code that looks for [data-scroll] will eventually be folded
	// into the jqm page processing code when scrollview support is "official"
	// instead of "experimental".

	$page.find(":jqmData(scroll):not(.ui-scrollview-clip)").each(function(){
		var $this = $(this);
		// XXX: Remove this check for ui-scrolllistview once we've
		//      integrated list divider support into the main scrollview class.
		if ($this.hasClass("ui-scrolllistview")){
			$this.scrolllistview();
		}
		else
		{
			var st = $this.jqmData("scroll") + "";
			var paging = st && st.search(/^[xy]p$/) != -1;
			var dir = st && st.search(/^[xy]/) != -1 ? st.charAt(0) : null;

			var opts = {};
			if (dir)
				opts.direction = dir;
			if (paging)
				opts.pagingEnabled = true;

			var method = $this.jqmData("scroll-method");
			if (method)
				opts.scrollMethod = method;

			$this.scrollview(opts);
			var id = $this.attr('id');
			$($this.children()[0]).css({height: 'auto'});
			if(id.indexOf('Custom-')>=0 || id.indexOf('Form-')>=0){
				//$($this.children()[0]).css({height: (GS.screenY-$("#footer").height()-$("#header").height()-10)+'px'});
				for (var i = 0; i < app.tabs.length; i++) {
					if (id.indexOf(app.tabs[i].tabId) >= 0) {
						if (app.tabs[i].controls.length > 0) {
							var maxBottom = parseInt(app.tabs[i].controls[0].frame.height) + parseInt(app.tabs[i].controls[0].frame.top);
							for (var j = 1; j < app.tabs[i].controls.length; j++) {
								if (parseInt(app.tabs[i].controls[j].frame.height) + parseInt(app.tabs[i].controls[j].frame.top) > maxBottom) {
									maxBottom = parseInt(app.tabs[i].controls[j].frame.height) + parseInt(app.tabs[i].controls[j].frame.top);
								}
							}
							
							$($this.children()[0]).css({height: maxBottom + 'px'});
						}
						break;
					}
				}
				//$this.css({height: GS.screenY+'px'});
			}
		}
	});

	// For the demos, we want to make sure the page being shown has a content
	// area that is sized to fit completely within the viewport. This should
	// also handle the case where pages are loaded dynamically.

	ResizePageContentHeight(event.target);
}