/**
 * Call Button
 */

var CallButton = {
		type: 'CallButton',
		drawControl: function(control, tab){
			var tabDiv = $("#"+tab.tabType+"-"+tab.tabId);
			var imageUrl = control.imageUrl;
			var ctrlDiv = $("<a>" + control.title + "</a>")
							.attr("data-role", "button")
							.attr('href', 'tel:'+control.phoneNumber)
							.addClass('control-button')
							.data('control', control)
							.data('number', control.phoneNumber)
							.css({width: control.frame.width+'px', 
								height: control.frame.height+'px',
								position: 'absolute',
								top: control.frame.top+'px',
								left: control.frame.left+'px',
								margin: '0px',
								'font-size': '14px'})
							.click(function(){
								//call($(this).data('number'));
								//return false;
								Log.AddActivity({ name: 'clickedCallButton', params: [ { paramName: 'phone', paramValue: $(this).data('number') } ] });
							});
			if(imageUrl !== undefined){
				ctrlDiv = $('<a></a>')
							.attr('href', 'tel:'+control.phoneNumber)
							.append(
								$('<img></img>')
											.attr('src', imageUrl)
											.css({width: control.frame.width+'px', 
												height: control.frame.height+'px',
												position: 'absolute',
												top: control.frame.top+'px',
												left: control.frame.left+'px',
												margin: '0px',
												'font-size': '10px'})
											.click(function(){
												//return false;
											})
								);
					
			}
			//ctrlDiv.button();
			tabDiv.append(ctrlDiv);
		}
}