/**
 * Form Button
 */

var FormButton = {
		type: 'FormButton',
		drawControl: function(control, tab){
			var tabDiv = $("#"+tab.tabType+"-"+tab.tabId);
			var uid = control.formView.formId;
			var screenDiv = $('<div></div>')
								.attr('id', 'FormButton' + '-' + uid)
								.css({display:'none', height: GS.screenY + 'px'})
								.addClass('screen-view')
								.attr("data-scroll", "y")
								.addClass('custom-tab');
			$("#content-body").append(screenDiv);

			var imageUrl = control.imageUrl;
			
			var ctrlDiv = $('<a></a>')
							.append(
								$('<img></img>')
											.data('screenId', 'FormButton-' + uid)
											.attr('src', imageUrl)
											.css({width: control.frame.width+'px', 
												height: control.frame.height+'px',
												position: 'absolute',
												top: control.frame.top+'px',
												left: control.frame.left+'px',
												margin: '0px',
												'font-size': '10px'})
											.click(function(){
												$('.screen-view').css({display:'none'});
												$($("#" + $(this).data('screenId')).children()[0]).css({ height: GS.screenY + 'px' });
												GS.showBackBtn();
												BackStack.down({ screenId: $(this).data("screenId") });
												ScrollUp($(this).data('screenId'));
												$("#" + $(this).data('screenId')).css({ display: 'block', height: GS.screenY + 'px' });
												//return false;
											})
								);
			
			tabDiv.append(ctrlDiv);
		}
}