/**
 * Label Element
 */

var Label = {
		type: 'Label',
		drawControl: function(control, tab){
			var tabDiv = $("#"+tab.tabType+"-"+tab.tabId);
			var content = control.text;
			var strings = control.text.split('\n');
			if(strings.length > 1){
				content = '';
				for(var i = 0; i < strings.length; i++){
					content += strings[i];
					if(i != strings.length - 1){
						content += '<br/>';
					}
				}
			}
			var label = $('<label>' + content + '</label>')
							.css({
								width: control.frame.width+'px', 
								height: control.frame.height+'px',
								//position: 'absolute',
								//top: control.frame.top+'px',
								//left: control.frame.left+'px',
								'font-size': control.fontSize + 'px',
								'font-family': control.font,
								color: 'rgb('+ control.color.red + ',' + control.color.green + ',' + control.color.blue + ')',
								'text-align': (control.textAlignment !== undefined)?control.textAlignment:'center'
							});
			var div = $('<div></div>')
						.css({
							'text-align':control.textAlignment,
							width: control.frame.width+'px', 
							height: control.frame.height+'px',
							position: 'absolute',
							top: control.frame.top+'px',
							left: control.frame.left+'px'
						})
						.addClass('ui-control-container')
						.append(label);
			tabDiv.append(div);
		}
}