/**
 * MultipleChoice List
 */

var MultipleChoiceList = {
		type: 'MultipleChoiceList',
		drawControl: function(control, tab){
			var tabDiv = $("#"+tab.tabType+"-"+tab.tabId);
			var imageUrl = control.imageUrl;
			var inputId = 'select-input-' + control.controlId;
			$("#"+inputId).remove();
			var kX = GS.screenX/320;
			var ctrlDiv = $('<select name="' + inputId + '" id="' + inputId + '" data-native-menu="false"></select>')
							.addClass('input-field')
							.data('control', control)
							.data('controlId', control.controlId)
							.data('required', control.required)
							.css({
								width: control.frame.width+'px',
								height: control.frame.height+'px',
								top: control.frame.top+'px',
								left: control.frame.left+'px',
								position: 'absolute',
								padding: '0px',
								display: 'none',
								'font-size': (16 * kX) + 'px'
							});
			if(control.selectionType == 'multiple'){
				ctrlDiv.attr('multiple', "multiple");
			}
			for(var i=0; i<control.options.length;i++){
				var option = $('<option value="' + control.options[i] + '">'+control.options[i]+'</option>');
				if(control.selectionType == 'multiple' && i==0){
					option.attr('selected', 'selected');
				}
				ctrlDiv.append(option);
			}
			//ctrlDiv.selectmenu();
			var fieldContainer = $('<div></div>')
									//data-role="fieldcontain"
									.addClass('form-field-set')
									.addClass('ui-control-container')
									.css({
										width: control.frame.width+'px',
										height: control.frame.height+'px',
										top: control.frame.top+'px',
										left: control.frame.left+'px',
										position: 'absolute',
										margin: '0px'
									})
									.addClass('choice-selector');
			tabDiv.append(fieldContainer.append(ctrlDiv));
		}
	}