/**
 * Nearby
 */

var Nearby = {
				type: 'Nearby',
				tab: null,
				GetScreen:function(tab){
					Nearby.tab = tab;
					var div= $("#"+ tab.tabType+'-'+tab.tabId);
					div.empty();
					if(tab.dataSource == "Google"){
						//load keywords
						var location = 'Portsmouth, NH, USA';
						if(GS.location != null){
							//location = { latitude: GS.location.latitude, longitude: GS.location.longitude };
							location = GS.location.latitude+","+GS.location.longitude;
						}
						if(tab.tabType == "NearbyNoCategories"){
							search.local(tab.searchText,
									tab.searchText, 
									location, 
									Nearby.drawStores, 
									$("#"+ tab.tabType+'-'+tab.tabId),
									tab,
									false
							);
							/*if(window.Ext !== undefined){
								var json = window.Ext.GetLocalStoresJson(tab.searchText, GS.location.latitude, GS.location.longitude);
								var obj = eval("(" + json + ")");
								var stores = obj.responseData.results;
								Nearby.drawStores(stores, $("#"+ tab.tabType+'-'+tab.tabId), tab, false);
							}
							else{
								search.local(tab.searchText,
										tab.searchText, 
										location, 
										Nearby.drawStores, 
										$("#"+ tab.tabType+'-'+tab.tabId),
										tab,
										false
								);
							}*/
						}
						else{
							//Nearby.DrawWebItems(tab.searchText, tab);
							
							var url = GS.processorUrl+"/RequestProcessor.ashx?cmd=getNearbyCategories" +
									"&controlId=" + tab.tabId +
									"&appDbId=" + appId;
							$.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(url), 
						    		function (data, status){
							    		//alert("Status: " + status);
							    		if(status == 'success'){
							    			//alert('success');
							    			var rawXml = unescape(proxy_resp.content);
							    			var xmlDoc = $.parseXML(rawXml);
							    			var catArray = $(xmlDoc).find('category');
							    			var ul = $('<ul data-role="listview" class="ui-listview" id="search-categories-' + tab.tabId + '"></ul>');
							    			ul.addClass('rss-ul').css({'margin':'0px'}).addClass('category-ul');
							    			for(var i=0;i<catArray.length;i++){
							    				var cat = catArray[i];
							    				var name = $(cat).find('name').text();
							    				var query = $(cat).find('query').text();
							    				var icon = $(cat).find('icon').text();
							    				var category = { 'name': name, 'query':query, 'icon':icon};
							    				ul.append(Nearby.getCategoryItem(category, i, tab));
							    			}
							    			$('#'+tab.tabType+'-'+tab.tabId).append(ul);
							    			ul.listview();
							    		}
						});
						}
					}
					if(tab.tabType == 'NearbyNoCategories' && tab.dataSource == "Database"){
			            var url = GS.processorUrl+"/RequestProcessor.ashx?cmd=getBusinesses" +
						"&controlId=" + tab.tabId +
						"&appId=" + app.appId;
			            $.getScript(GS.snappiiProxyTool + "&url=" + escape(url), 
					    		function (data, status){
						    		//alert("Status: " + status);
						    		if(status == 'success'){
						    			var rawXml = unescape(proxy_resp.content);
						    			var xmlDoc = $.parseXML(rawXml);
						    			var businesses = $(xmlDoc).find('business');
						    			var ul = $('<ul data-role="listview" class="ui-listview" id="search-list-' + tab.tabId + '"></ul>');
						    			ul.addClass('rss-ul').css({'margin':'0px'});
						    			for(var i=0; i<businesses.length;i++){
						    				var bus = $(businesses[i]);
						    				var name = bus.find('name')[0].textContent;
						    				var url = bus.find('url')[0].textContent;
						    				var description = bus.find('description')[0].textContent;
						    				var logo = bus.find('logo')[0].textContent;
						    				var emails = bus.find('email');
						    				var mailArray = new Array();
						    				for(var j=0; j<emails.length; j++){
						    					var mail = emails[j];
						    					var email = mail.textContent;
						    					mailArray.push(email);
						    				}
						    				var addresses = bus.find('address');
						    				var adrArray = new Array();
						    				for(var j=0;j<addresses.length;j++){
						    					var address = addresses[j];
						    					var city = $(address).find('city')[0].textContent;
						    					var country = $(address).find('country')[0].textContent;
						    					var postalCode = $(address).find('postalCode')[0].textContent;
						    					var region = $(address).find('region')[0].textContent;
						    					var street = $(address).find('street')[0].textContent;
						    					var latitude = $(address).find('latitude')[0].textContent;
						    					var longitude = $(address).find('longitude')[0].textContent;
						    					adrArray.push({city:city, country:country, postalCode:postalCode, 
						    									region:region, street:street, latitude:latitude, 
						    									longitude:longitude});
						    					
						    				}
						    				var phones = bus.find('phones');
						    				var phArray = new Array();
						    				for(var j=0;j<phones.length;j++){
						    					var phone = phones[j].textContent;
						    					phArray.push(phone);
						    				}
						    				
						    				var business = {name:name, description:description, logo:logo, url:url, 
						    								emails: mailArray, addresses: adrArray, phones: phArray, num: i};
						    				ul.append(Nearby.drawStoreItem(business, tab, i));
						    			}
						    			$('#'+tab.tabType+'-'+tab.tabId).append(ul);
						    			ul.listview();
						    		}
			            		});
					}
				},
				getCategoryItem: function(category, num, tab){
					var li = $('<li></li>')
								.css({ 'min-height': '10px', 'padding-left': '50px' })
								.data('itemId', tab.tabId+'-'+num)
								.data('category', category)
								.data('tab', tab)
								.click(function(){
										var cat = $(this).data('category');
										$.mobile.showPageLoadingMsg();
										var location = 'Portsmouth, NH, USA';
										if(GS.location != null){
											//location = { latitude: GS.location.latitude, longitude: GS.location.longitude };
											location = GS.location.latitude+","+GS.location.longitude;
										}
										
										if(window.Ext !== undefined){
											$.mobile.showPageLoadingMsg();
											var json = window.Ext.GetLocalStoresJson(cat.query, GS.location.latitude, GS.location.longitude);
											var obj = eval("(" + json + ")");
											var stores = obj.responseData.results;
											Nearby.drawStores(stores, $("#nearby-screen-"+$(this).data('itemId')), $(this).data('tab'));
											$.mobile.hidePageLoadingMsg();
										}
										else{
											search.local(cat.name, cat.query, location, Nearby.drawStores, $("#nearby-screen-"+$(this).data('itemId')), $(this).data('tab'));
										}
										
										Log.AddActivity({ name: 'viewedNearbyCategory', params: [ { paramName: 'category', paramValue: cat.name } ] });
										$("#nearby-screen-"+$(this).data('itemId')).css({display:'block'});
										GS.showBackBtn();
										BackStack.down({ screenId: "nearby-screen-"+$(this).data('itemId') });
										/*GS.BackBtn
										//.unbind()
										.data('screenid', "nearby-screen-"+$(this).data('itemId'))
										.click(function(){
											$("#"+$(this).data('screenid')).css({display:'none'});
											GS.hideBackBtn();
										});*/
										return false;
								});
					var icon = $('<img></img>')
									.attr('src', category.icon)
									.css({top: '10px', left: '10px', 'max-width': '30px', 'max-height': '30px'});
					var name = $('<p>' + category.name + '</p>')
											.css({'font-size':'12px', 'margin-left': '10px', 'margin-bottom': '5px', 'margin-top': '5px', 'font-weight':'normal'});
					var arrow = $('<span class="ui-icon ui-icon-arrow-r"></span>').css({right: '30px'});
					
					var screen = $('<div></div>')
									.attr('id', 'nearby-screen-' + tab.tabId + '-' + num)
									.css({display:'none', top: '0px'})
									.addClass('child-screen');
					$("#"+ tab.tabType+'-'+tab.tabId).append(screen);
					
					li.append(icon).append(name).append(arrow);
					return li;
				},
				drawStores: function(stores, screen, tab, showNoResultsMessage){
					if(stores.length < 1){
						screen.empty();
						screen.append(
								$('<p>No results found</p>')
									.css({ 'font-size':'22px' })
						).css({ height: GS.screenY + 'px' });
						if(showNoResultsMessage !== undefined){
							if(showNoResultsMessage == true){
								alert('Results not found');
							}
							else{

							}
						}
						else{
							alert('Results not found');
						}
						$("#content-body").css({height: GS.screenY + 'px'});
						$($("#content-body").children()[0]).css({height: GS.screenY + 'px'});
						$.mobile.hidePageLoadingMsg();
						return;
					}
					
					var listId = screen.attr('id')+'-list';
					$("#"+listId).remove();
					var resultList = $('<ul data-role="listview" data-inset="true" data-theme="d"></ul>')
										.attr('id', listId);
					screen.css({ height: (50*stores.length + 150)+ 'px' });
					screen.parent().css({ height: (50*stores.length + 150) + 'px' });
					$("#content-body").css({height: GS.screenY + 'px'});
					$($("#content-body").children()[0]).css({height: GS.screenY + 'px'});
					for(var i=0;i<stores.length;i++){
						var store = stores[i];
						var title = store.title;
						var address = store.city + ', ' + ((store.streetAddress !== undefined) ? store.streetAddress : store.street);
						var mapUrl = store.staticMapUrl;
						if(store.staticMapUrl === undefined){
							mapUrl = store.mapUrl;
						}
						var coords = mapUrl.split('markers=')[1];
						var lat = coords.split(',')[0];
						var lng = coords.split(',')[1];
						store.lat = lat;
						store.lng = lng;
						store.addresses = new Array();
						store.emails = new Array();
						store.phones = new Array();
						store.description = title;
						store.addresses.push(address);
						if(store.number !== undefined){
							store.phones.push(store.number);
						}
						if(store.phoneNumbers != undefined){
							if(store.phoneNumbers.length > 0){
								store.phones.push(store.phoneNumbers[0].number);
							}
						}
						store.num = i;
						var titleDiv = $('<label>'+title+'</label>')
										.css({'font-size':'14px', 'font-weight':'bold'});
						var addressDiv = $('<label>'+address+'</label>')
										.css({'font-size':'14px'});
						var li = $('<li></li>');
						li.append(titleDiv).append('<br/>').append(addressDiv);
						//resultList.append(li);
						resultList.append(Nearby.drawStoreItem(stores[i], tab, i));
					}
					screen.append(resultList);
					$('#' +listId).listview();
					$("#search-categories-" + tab.tabId).css({ display: 'none', height: '1px' });
					$("#" + tab.tabType + '-' + tab.tabId).find('.category-ul').css({ display: 'none'});
					$.mobile.hidePageLoadingMsg();
				},
				drawStoreItem: function(item, tab, number){
					var li = $('<li></li>')
						.attr('data-theme', 'c')
						.addClass('ui-btn')
						.addClass('ui-li')
						.addClass('ui-btn-icon-right')
						.addClass('ui-btn-up-c')
						.css({width:'100%', 'border-collapse': 'collapse'})//.css({width:GS.screenX+'px'})
						//.data('url',item.ddUrl)
						.data('itemId', tab.tabId+'-'+number)
						.data('tabScreen', tab.tabName + '-' + tab.tabId)
						.click(function(){
							 //$('#' + $(this).data('tabScreen')).css({height: $("#search-screen-"+$(this).data('itemId')).css('height')});
							 $("#search-screen-"+$(this).data('itemId')).find('ul').listview();	
							 $("#search-screen-"+$(this).data('itemId')).css({display:'block'});
							 $("#" + tab.tabType + '-' + tab.tabId).css({ height: GS.screenY + 'px' })
								GS.showBackBtn();
							 	BackStack.down({ screenId: "search-screen-"+$(this).data('itemId') });
								/*GS.BackBtn
								//.unbind()
								.data('screenid', "search-screen-"+$(this).data('itemId'))
								.click(function(){
									$("#"+$(this).data('screenid')).css({display:'none'});
									GS.hideBackBtn();
								});*/
								return false;
						});
					$('#search-screen-' + tab.tabId+'-' + item.num+ '-'+number).remove();
					var mainAddress = null;
					var address = '';
					var email = '';
					var phone = '';
					if(item.addresses.length>0){
						mainAddress = item.addresses[0];
						if(mainAddress.city !== undefined){
							address = mainAddress.city + ', ' + mainAddress.street;
						}
						else{
							address = mainAddress;
						}
					}
					if(item.emails.length>0){
						email = item.emails[0];
					}
					if(item.phones.length>0){
						phone = item.phones[0];
					}
					var screen = $('<div></div>')
									.attr('id', 'search-screen-' + tab.tabId+'-'+number)
									.css({display:'none', top: '0', height: GS.screenY + 'px'})
									.addClass('child-screen');

					var descriptionArea = $('<div></div>')
											.css({margin:'10px'})
											.append(
													$('<label>' + item.description + '</label>')
														.css({ color:'#F0F0F0', 'font-size':'16px' })
											)
											.append('<br/>')
											.append(
													$('<label>' + address + '</label>')
														.css({ color:'#F0F0F0', 'font-size':'16px' })
											);
					var mapScreen = $('<div></div>')
										.attr('id', 'nearby-map-screen-' + tab.tabId+'-'+number)
										.css({display:'none', top: '0'})
										.addClass('child-screen')
										.append(
											$('<iframe src="' + GS.mapPageUrl + '" style="width:100%; height:' + GS.screenY + 'px"></iframe>')
										);
					var twitterLink = "http://twitter.com/home?status=" + escape(item.description + "; " + address);
					var actionList = $('<ul data-role="listview" data-inset="true" data-theme="d">'+
										((phone.length > 0) ? ('<li><a href="tel:' + phone + '">Call</a></li>') : '') +
										//'<li><a href="'+item.ddUrl+ '" target="_blank">Map and Direction</a></li>'+
										((phone.length > 0) ? ('<li><a href="tel:' + phone + '">Send SMS</a></li>') : '')+
										((email.length > 0) ? ('<li><a href="mailto:' + email + '">Send Email</a></li>') : '')+
										//'<li><a href="#">Reviews</a></li>'+
										((phone.length > 0) ? ('<li><a href="tel:' + phone + '">Add to Contacts</a></li>') : '')+
										//'<li><a href="#">Add to Favorites</a></li>'+
										'<li><a href="' + twitterLink + '">Add to Twitter</a></li>'+
										'<li><a href="http://facebook.com">Add to Facebook</a></li>'+
									 '</ul>');
					actionList.append(
							$('<li><a href="#">Add to Favorites</a></li>')
								.data('item', item)
								.click(function(){
									Favorites.AddToFavorites($(this).data('item'));
								})
					);
					actionList.append(
							$('<li><a href="#">Reviews</a></li>')
								.data('item', item)
								.data('review-screen','search-screen-' + tab.tabId + '-' + number + '-review-screen')
								.click(function(){
									$(".child-screen").css({ display: 'none' });
									BackStack.down({ screenId: $(this).data("review-screen") });
									$("#" + $(this).data("review-screen")).css({ display: 'block' });
									return false;
								})
					);
					actionList.append(
							$('<li><a href="#">Map and Direction</a></li>')
								.data('item', item)
								.data('map-screen','nearby-map-screen-' + tab.tabId+'-'+number)
								.click(function(){
									//Favorites.AddToFavorites($(this).data('item'));
									/*$.mobile.showPageLoadingMsg();
									ScrollUp($(this).data("map-screen"));
									window.localStorage.setItem("map-center", GS.location.latitude+","+GS.location.longitude);
									window.localStorage.setItem("map-latitude", GS.location.latitude);
									window.localStorage.setItem("map-longitude", GS.location.longitude);
									window.localStorage.setItem("map-height", GS.screenY - 250);
					    			var markersJson = "{ 'markers': [" + JSON.stringify($(this).data('item')) + "]}";
					    			window.localStorage.setItem("map-markers", markersJson);
					    			$("#" + $(this).data("map-screen")).find('iframe')[0].contentDocument.location.reload(true);
									$(".child-screen").css({ display: 'none' });
									BackStack.down({ screenId: $(this).data("map-screen") });
									$("#" + $(this).data("map-screen")).css({ display: 'block' });
									$.mobile.hidePageLoadingMsg();*/
									var markersJson = "{ 'markers': [" + JSON.stringify($(this).data('item')) + "]}";
									var mapUrl = GS.mapPageUrl + "?height=" + (GS.screenY - 250)+
													"&center=" + (GS.location.latitude+","+GS.location.longitude)+
													"&lat=" + GS.location.latitude +
													"&lng=" + GS.location.longitude +
													"&markers=" + escape(markersJson);
									if(window.Ext !== undefined){
										//window.Ext.ShowWebPage(mapUrl);
										window.location = mapUrl;
									}
								})
					);
					screen.append(descriptionArea).append(actionList);					
					
					var reviewDiv = Review.GetReviewsScreen(item, $("#"+ tab.tabType+'-'+tab.tabId), 'search-screen-' + tab.tabId+'-'+number);
					$("#"+ tab.tabType+'-'+tab.tabId)
							.append(screen)
							.append(mapScreen)
							.append(reviewDiv);
					Review.GetReviews(reviewDiv, item);
					
					var width = '100%'; //(GS.screenX - 40)+'px'
					var header = $('<h3>'+item.description+'</h3>')
								.css({'font-size':'12px', 'margin-left': '10px', 'margin-bottom': '5px', 'margin-top': '5px', 'width':width});
					var description = $('<p>' + address + '</p>')
								.css({'font-size':'12px', 'margin-left': '10px', 'margin-bottom': '5px', 'margin-top': '5px', 'font-weight':'normal', 'width':width});
					var arrow = $('<span class="ui-icon ui-icon-arrow-r"></span>').css({right: '40px'});
					li.append(header).append(description).append(arrow);
					return li;
				},
				onOpen: function(tab){
					$("#Nearby-" + tab.tabId).css({display: 'block', height: '100%'});
					$("#search-categories-" + tab.tabId).css({display: 'block', height: '100%'});
					$("#" + tab.tabType + "-" + tab.tabId).find(".child-screen").css({display: 'none'});
					$($("#Nearby-" + tab.tabId).children()[0]).css({display: 'block', height: '100%'});
				},
				DrawWebItems: function(query, tab){
					var div= $("#"+ tab.tabType+'-'+tab.tabId);
					var url = GS.googleSearchUrl+
								"?cat=gwd%2FTop%2FShopping" +
								"&num=10"+
								"&q="+escape(query)+
								"&start=0";
					var googleQuery = query;
					if(tab.websiteUrl !== undefined){
						googleQuery = query + " site:" + tab.websiteUrl;
					}
					var urlGet = GS.snappiiUrl + '/handlers/appbuilder.ashx?type=getOnlineStores' +
			                    '&query=' + escape(googleQuery)+
			                    '&start=0' +
			                    '&format=json';
					
					$.getScript("http://snappii.com/proxy.ashx?convert=json&url=" + escape(urlGet), 
				    		function (data, status){
				    		//alert("Status: " + status);
				    		if(status == 'success'){
				    			var rawContent = unescape(proxy_resp.content);
				    			var json = eval("("+ rawContent +")");
				    			var ul = $('<ul data-role="listview" class="ui-listview" id="search-list-' + tab.tabId + '"></ul>');
				    			ul.css({ 'margin-top':'10px' });
				    			ul.addClass('rss-ul');
				    			for(var i=0;i<json.stores.store.length;i++){
				    				ul.append(Search.drawOnlineSearchItem(json.stores.store[i], tab, i));
				    			}
				    			$('#nearby-results-' + tab.tabId).remove();
				    			$($('#'+tab.tabType+'-'+tab.tabId).children()[0]).append(
			    						$('<div></div>')
			    							.attr('id', 'nearby-results-' + tab.tabId)
			    							.css({ height: (50 * json.stores.store.length) + 'px' })
			    							.append(ul)
			    					);
				    			ul.listview();
				    			div.append(ul);
				    		}
				    		$.mobile.hidePageLoadingMsg();
				    });
		},
		drawOnlineSearchItem: function(item, tab, number){
			var li = $('<li></li>')
			.attr('data-theme', 'c')
			.addClass('ui-btn')
			.addClass('ui-li')
			.addClass('ui-btn-icon-right')
			.addClass('ui-btn-up-c')
			.css({ 'margin-left':'15px', 'height': '45px' })
			.css({width:GS.screenX+'px'})
			.data('url',item.url)
			.data('itemId', tab.tabId+'-'+number)
			.click(function(){
				 $("#nearby-result-screen-"+$(this).data('itemId')).find('ul').listview();
				 $("#nearby-result-"+$(this).data('itemId')).css({display:'block'});
				 ScrollUp(tab.tabType+'-'+tab.tabId);
				 $("#" + tab.tabType + '-' + tab.tabId).css({ height: GS.screenY + 'px' })
					GS.showBackBtn();
				 	BackStack.down({ screenId: "nearby-result-"+$(this).data('itemId') });
					/*GS.BackBtn
					//.unbind()
					.data('screenid', "search-screen-"+$(this).data('itemId'))
					.click(function(){
						$("#"+$(this).data('screenid')).css({display:'none'});
						GS.hideBackBtn();
					});*/
					return false;
			});
	    var url = item.url;
	    if(url.indexOf('http')<0){
	    	url = 'http://' + url;
	    }
		$('#nearby-result-screen-' + tab.tabId+'-'+number).remove();
		var screen = $('<div></div>')
						.attr('id', 'nearby-result-screen-' + tab.tabId+'-'+number)
						.css({display:'none', top: '0px'})
						.addClass('child-screen');

		$("#"+ tab.tabType+'-'+tab.tabId).append(screen);
		var width = '100%'; //(GS.screenX - 40)+'px'
		var header = $('<h3>'+item.headline+'</h3>')
					.css({'font-size':'12px', 'margin-left': '10px', 'margin-bottom': '5px', 'margin-top': '5px', 'width':width});
		var twitterLink = "http://twitter.com/home?status=" + escape(item.headline + "; " + url);
		var actionList = $('<ul data-role="listview" data-inset="true" data-theme="d">'+
							'<li><a href="'+ url+ '">Check site</a></li>'+
							'<li><a href="#">Reviews</a></li>'+
							//'<li><a href="#">Add to Favorites</a></li>'+
							'<li><a href="' + twitterLink + '">Add to Twitter</a></li>'+
							'<li><a href="http://facebook.com">Add to Facebook</a></li>'+
						 '</ul>');
		actionList.append(
				$('<li><a href="#">Add to Favorites</a></li>')
					.data('item', item)
					.click(function(){
						Favorites.AddToFavorites($(this).data('item'));
					})
		);
		var descriptionArea = $('<div></div>')
									.css({margin:'10px'})
									.append(
											$('<label>' + item.headline + '</label>')
												.css({ color:'#F0F0F0', 'font-size':'16px' })
									)
									.append('<br/>')
									.append(
											$('<label>' + item.description + '</label>')
												.css({ color:'#F0F0F0', 'font-size':'16px' })
									);
		var description = $('<p>' + item.description + '</p>')
							.css({'font-size':'12px', 'margin-left': '10px', 'margin-bottom': '5px', 'margin-top': '5px', 'font-weight':'normal', 'width':width});
		var arrow = $('<span class="ui-icon ui-icon-arrow-r"></span>').css({right: '30px'});
		screen.append(descriptionArea).append(actionList);	
		li.append(header).append(description).append(arrow);
		return li;
		}
				}