/**
 * RSS Tab
 */

var RSS = {
		type: 'RSS',
		GetScreen:function(tab){
			var div=$('<div></div>')
						.attr('id',tab.tabType+'-'+tab.tabId);
			var url = tab.url;
		    $.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(url), 
		    		function (data, status){
		    		//alert("Status: " + status);
		    		if(status == 'success'){
		    			//alert('success');
		    			var xml = unescape(proxy_resp.content);
		    			var xmlDoc = $.parseXML(xml);
		    			var items = $(xmlDoc).find('item');
		    			var ul = $('<ul data-role="listview" class="ui-listview "></ul>');
		    			ul.addClass('rss-ul').css({margin: '0'});
		    			for(var i=0;i<items.length;i++){
		    				var item = $(items[i]);
		    				var title = item.find('title').text();
		    				var link = item.find('link').text();
		    				var description = item.find('description').text();
		    				var pubDate = item.find('pubDate').text();
		    				var timeFormat = pubDate.split(':')[0] + ':' + pubDate.split(':')[1];
		    				var guid = item.find('guid').text();
		    				var rssItem = {'item':item,
		    						'title':title,
		    						'link':link,
		    						'description':description,
		    						'pubDate':pubDate,
		    						'timeFormat':timeFormat,
		    						'guid':guid};
		    				ul.append(RSS.getRSSItem(rssItem));
		    				
		    				
		    				/*var li = '<li data-theme="c" class="ui-btn ui-btn-icon-right ui-btn-up-c">'+
		    				'<div class="ui-btn-inner ui-li"><div class="ui-btn-text">'+
		    				'<a href="'+guid+'" class="ui-link-inherit">'+
		    				'<p class="ui-li-aside ui-li-desc">'+timeFormat+'</p>'+
		    				'<h3 class="ui-li-heading" style="font-size:10px">'+title+'</h3>'+
		    				//'<p class="ui-li-desc" style="font-size:12px">'+timeFormat+'</p>'+
							'<p class="ui-li-desc" style="font-size:10px">'+description+'</p>'+
							'</a></div><span class="ui-icon ui-icon-arrow-r"></span></div></li>';
		    				ul.append($(li));*/
		    			}
		    			$('#'+tab.tabType+'-'+tab.tabId).append(ul);
		    		}
		    	 });
		},
		getRSSItem: function(item){
			var url = item.guid;
			if(url.indexOf('http') < 0){
				url = item.link;
			}
			var li = $('<li></li>')
						.attr('data-theme', 'c')
						.addClass('ui-btn')
						.addClass('ui-li')
						.addClass('ui-btn-icon-right')
						.addClass('ui-btn-up-c')
						.css({width:GS.screenX+'px'})
						.data('url', url)
						.click(function(){
							 var url = $(this).data('url');
							 window.Ext.ShowWebPage(url);
							 return false;
						});
			var width = (GS.screenX - 40)+'px';
			var header = $('<h3>'+item.title+'</h3>')
						.css({'font-size':'12px', 'margin-left': '5px', 'margin-bottom': '5px', 'margin-top': '5px', 'width':width});
			var description = $('<p>' + item.description + '</p>')
						.css({'font-size':'12px', 'margin-left': '5px', 'margin-bottom': '5px', 'margin-top': '5px', 'font-weight':'normal', 'width':width});
			var arrow = $('<span class="ui-icon ui-icon-arrow-r"></span>').css({right: '30px'}); //.css({left: (GS.screenX - 20)+'px'});
			
			var table = $('<table></table>')
						.append(
							$('<tr></tr>')
								.append(
										$('<td></td>')
											.append(header).append(description)
								)
								.append(
										$('<td></td>')
								)
						)
						.css({'width': width});
			li.append(header).append(description).append(arrow);
			return li;
		}
		
}