/**
 * Video Button
 */

var VideoButton = {
		type: 'VideoButton',
		drawControl: function(control, tab){
			var tabDiv = $("#"+tab.tabType+"-"+tab.tabId);
			var imageUrl = control.imageUrl;			
			var hash = GS.guid();
			var screen = $('<div></div>')
							.attr('id', 'video-screen-'+hash)
							.addClass('child-screen')
							.append(control.YouTubeEmbedCode)
							.css({
								display:'none',
								'height': '100%', 
								width: '100%', 
								'background-color':'#808080',
								'text-align': 'center',
								position: 'absolute',
								'z-index': 100000});
			var	ctrlDiv = $('<img></img>')
								.attr('src', imageUrl)
								.data('hash', hash)
								.css({width: control.frame.width+'px', 
									height: control.frame.height+'px',
									position: 'absolute',
									top: control.frame.top+'px',
									left: control.frame.left+'px',
									margin: '0px',
									'font-size': '10px'})
								.click(function(){
									/*$('#video-screen-'+$(this).data('hash')).css({display:'block'});
									$("#header").find('div')
										.data('screenid', 'video-screen-'+$(this).data('hash'))
										.css({display:'block'})
										.click(function(){
											$(this).css({display:'none'});
											$("#"+$(this).data('screenid')).css({display:'none'});
											return false;
										});*/
								});

			tabDiv.append($('<a></a>').attr('href', VideoButton.getYoutubeLink(control.YouTubeEmbedCode)).append(ctrlDiv));
			//tabDiv.append(screen);
		},
		getYoutubeLink: function(embededCode){
			//"<object width=\"212\" height=\"172\"><param name=\"movie\" value=\"http://www.youtube.com/v/jvsK83Q8k1U&f=gdata_videos&c=ytapi-my-clientID&d=nGF83uyVrg8eD4rfEkk22mDOl3qUImVMV6ramM\">
			//</param><param name=\"wmode\" value=\"transparent\"></param><embed src=\"http://www.youtube.com/v/jvsK83Q8k1U&f=gdata_videos&c=ytapi-my-clientID&d=nGF83uyVrg8eD4rfEkk22mDOl3qUImVMV6ramM\"type=\"application/x-shockwave-flash\" wmode=\"transparent\" width=\"212\" height=\"172\"></embed></object>"
			var raw = embededCode.split("value=\"")[1];
			var rawLink = raw.split("\"")[0];
			return rawLink.split("&")[0];
		}
}