/**
 * 
 */

var Scale = {
		scaleTab: function(tab){
			if(tab.controls !== undefined){
				var screenY = GS.screenY;
				var screenX = GS.screenX;
				var kX = screenX/320;
				var kY = screenY/320;
				for(var i=0; i< tab.controls.length; i++){
					var control = tab.controls[i];
					if( screenY != 480 && screenX != 320 ){
						var newFrame = { height: control.frame.height * kX, 
										 width: control.frame.width * kX,
										 left: control.frame.left * kX,
										 top: control.frame.top * kX };
						tab.controls[i].frame = newFrame;
						//control.frame = newFrame;
						if(control.fontSize !== undefined){
							tab.controls[i].fontSize = control.fontSize * kX;
						}
					}
					if(control.controlType == 'FormButton'){
						for(var j=0; j < control.formView.controls.length; j++){
							var formcontrol = control.formView.controls[j];
							if( screenY != 480 && screenX != 320 ){
								var newFrame = { height: formcontrol.frame.height * kX, 
												 width: formcontrol.frame.width * kX,
												 left: formcontrol.frame.left * kX,
												 top: formcontrol.frame.top * kX };
								//alert(newFrame.height + '; ' + formcontrol.frame.height)
								//tab.controls[i].formView.controls[j].frame = newFrame;
								control.formView.controls[j].frame = newFrame;
								if(formcontrol.fontSize !== undefined){
									control.formView.controls[j].fontSize = formcontrol.fontSize * kX;
								}
							}
						}
					}
				}
			}
			if(tab.tabType == 'CustomList'){
				var screenX = GS.screenX;
				if( screenY != 480 && screenX != 320 ){
					var kX = screenX/640;
					tab.control.listCellView.maxHeight = tab.control.listCellView.maxHeight * kX;
					for(var i = 0; i < tab.control.listCellView.cellControls.length; i++){
						var control = tab.control.listCellView.cellControls[i];
						var newFrame = { height: control.frame.height * kX, 
								 width: control.frame.width * kX * ((control.controlType == 'Label') ? 2 : 1),
								 left: control.frame.left * kX,
								 top: control.frame.top * kX };
						tab.control.listCellView.cellControls[i].frame = newFrame;
						if(control.fontSize !== undefined){
							tab.control.listCellView.cellControls[i].fontSize = control.fontSize * kX;
						}
					}
					for(var i = 0; i < tab.control.listDetailView.pageControls.length; i++){
						var control = tab.control.listDetailView.pageControls[i];
						var newFrame = { height: control.frame.height * kX * 2, 
								 width: control.frame.width * kX * 2,
								 left: control.frame.left * kX * 2,
								 top: control.frame.top * kX * 2};
						tab.control.listDetailView.pageControls[i].frame = newFrame;
						if(control.fontSize !== undefined){
							tab.control.listDetailView.pageControls[i].fontSize = control.fontSize * kX;
						}
					}
				}
			}
			return tab;
		}
}

var TypeWrapper = { "CustomList": List, "Nearby": Nearby, "NearbyNoCategories": Nearby, "Form": Form, "Favorites": Favorites, "Community": Discussion, "Map": Map, "Search": Search, "PoweredBy": PoweredBy };

var BackStack = {
		steps: [],
		up: function(){
			if(this.steps.length == 0){
				$("#back-btn-div").css({ display: 'none' });
				return;
			}
			var lastStep = this.steps.pop();
			var currentScreenId = this.steps[this.steps.length - 1].screenId;
			ScrollUp(currentScreenId);
			$("#" + lastStep.screenId).css({ display: 'none' });
			//$(".child-screen").css({ display: 'none' });
			$("#" + currentScreenId).css({ display: 'block',
											height: GS.screenY + 'px'
											});
			$("#" + currentScreenId).find('ul').css({ display: 'block', height: 'auto' });
			$("#" + currentScreenId).find('.category-ul').css({ display: 'block', height: 'auto' });
			if(this.steps.length == 1){
				$("#back-btn-div").css({ display: 'none' });
			}
		},
		down: function(step){
			this.steps.push(step);
			if(this.steps.length > 1){
				$("#back-btn-div").css({ display: 'block' });
			}
		},
		root: function(step){
			this.steps = new Array();
			this.steps.push(step);
		}
}